#########################################################################################
###### Data output
#########################################################################################

#### Acquired settings:
SETDataOutput <- list(	export = c(), #TRUE / FALSE
						filenames = c(), #filenames
						separator = ";",
						decimal = ",",
						folder = "foldername" )
						
#########################################################################################
#### Data output layout
#########################################################################################

####
#### Frame layout
#################
FROutRaw <- gtkFrame()
FROutRawOrig <- gtkFrame()
FROutRawSm <- gtkFrame()
FROutRawSlope <- gtkFrame()
FROutRawSlopeSd <- gtkFrame()
FROutRawCons <- gtkFrame()
FROutRawConsSd <- gtkFrame()
FROutRawAv <- gtkFrame()
FROutRawAvSm <- gtkFrame()
FROutRawAvSlope <- gtkFrame()
FROutRawAvSlopeSd <- gtkFrame()
FROutRawAvCons <- gtkFrame()
FROutRawAvConsSd <- gtkFrame()
FROutRawSd <- gtkFrame()
FROutMedium <- gtkFrame()
FROutMediumOrig <- gtkFrame()
FROutMediumSm <- gtkFrame()
FROutMediumSlope <- gtkFrame()
FROutMediumSlopeSd <- gtkFrame()
FROutMediumCons <- gtkFrame()
FROutMediumConsSd <- gtkFrame()
FROutMediumAv <- gtkFrame()
FROutMediumAvSm <- gtkFrame()
FROutMediumAvSlope <- gtkFrame()
FROutMediumAvSlopeSd <- gtkFrame()
FROutMediumAvCons <- gtkFrame()
FROutMediumAvConsSd <- gtkFrame()
FROutMediumSd <- gtkFrame()
FROutIC50 <- gtkFrame()

VectorOutputFramesObjects <- c(	"Data_raw" = "FROutRaw", "Data_rawOrig" = "FROutRawOrig", "Data_rawSm" = "FROutRawSm", "Data_rawSlope" = "FROutRawSlope", "Data_rawSlopeSd" = "FROutRawSlopeSd", "Data_rawCons" = "FROutRawCons", "Data_rawConsSd" = "FROutRawConsSd",
								"Data_rawAv" = "FROutRawAv", "Data_rawAvSm" = "FROutRawAvSm", "Data_rawAvSlope" = "FROutRawAvSlope", "Data_rawAvSlopeSd" = "FROutRawAvSlopeSd", "Data_rawAvCons" = "FROutRawAvCons", "Data_rawAvConsSd" = "FROutRawAvConsSd", "Data_rawSd" = "FROutRawSd",
								"Data_medium" = "FROutMedium", "Data_mediumOrig" = "FROutMediumOrig", "Data_mediumSm" = "FROutMediumSm", "Data_mediumSlope" = "FROutMediumSlope", "Data_mediumSlopeSd" = "FROutMediumSlopeSd", "Data_mediumCons" = "FROutMediumCons", "Data_mediumConsSd" = "FROutMediumConsSd",
								"Data_mediumAv" = "FROutMediumAv", "Data_mediumAvSm" = "FROutMediumAvSm", "Data_mediumAvSlope" = "FROutMediumAvSlope", "Data_mediumAvSlopeSd" = "FROutMediumAvSlopeSd", "Data_mediumAvCons" = "FROutMediumAvCons", "Data_mediumAvConsSd" = "FROutMediumAvConsSd", "Data_mediumSd" = "FROutMediumSd",
								"Data_IC50" = "FROutIC50")

VectorOutputFramesLabels <- c(	"Data_raw" = "Raw data", "Data_rawOrig" = "Unformatted raw data", "Data_rawSm" = "Smoothed raw data", "Data_rawSlope" = "Slope raw data", "Data_rawSlopeSd" = "Deviation slope raw data", "Data_rawCons" = "Consumption from raw data", "Data_rawConsSd" = "Deviation consumption from raw data",
								"Data_rawAv" = "Average raw data", "Data_rawAvSm" = "Smoothed average raw data", "Data_rawAvSlope" = "Slope average raw data", "Data_rawAvSlopeSd" = "Deviation slope average raw data", "Data_rawAvCons" = "Consumption from average raw data", "Data_rawAvConsSd" = "Deviation consumption average raw data", "Data_rawSd" = "Raw data standard deviation",
								"Data_medium" = "Normalisation data", "Data_mediumOrig" = "Unformatted normalisation data", "Data_mediumSm" = "Smoothed normalisation data", "Data_mediumSlope" = "Slope normalisation data", "Data_mediumSlopeSd" = "Deviation slope normalisation data", "Data_mediumCons" = "Consumption from normalisation data", "Data_mediumConsSd" = "Deviation consumption from normalisation data",
								"Data_mediumAv" = "Average normalisation data", "Data_mediumAvSm" = "Smoothed average normalisation data", "Data_mediumAvSlope" = "Slope average normalisation data", "Data_mediumAvSlopeSd" = "Deviation slope average normalisation data", "Data_mediumAvCons" = "Consumption from average normalisation data", "Data_mediumAvConsSd" = "Deviation consumption from average normalisation data", "Data_mediumSd" = "Normalisation data standard deviation",
								"Data_IC50" = "IC50 values and standard errors")

LBLDataOutputFrame <- gtkLabel("Select which datasets you want to export as .csv and give them filenames.")
LBLDataOutputFrame$setSizeRequest(-1, 25)
BXOutputSeparators <- gtkHBox(FALSE, 5)
BXOutputExecute <- gtkHBox(FALSE, 5)

BXOutputSeparators$setBorderWidth(5)
BXOutputExecute$setBorderWidth(5)

layoutDataOutput <- gtkVBox(FALSE, 5)

####
#### Separators
###############
LBLOutputSeparator <- gtkLabel("Separator:")
ENTOutputSeparator <- gtkEntry()
ENTOutputSeparator$setSizeRequest(30, 20)
LBLOutputDecimal <- gtkLabel("Decimal separator:")
ENTOutputDecimal <- gtkEntry()
ENTOutputDecimal$setSizeRequest(30, 20)
	BXOutputSeparators$packStart(LBLOutputSeparator, expand = FALSE, fill = FALSE)
	BXOutputSeparators$packStart(ENTOutputSeparator, expand = FALSE, fill = FALSE)
	BXOutputSeparators$packStart(LBLOutputDecimal, expand = FALSE, fill = FALSE)
	BXOutputSeparators$packStart(ENTOutputDecimal, expand = FALSE, fill = FALSE)
	
#########################################################################################
#### Data output interactive
#########################################################################################

####
#### Signal: Separator entered
##############################
gSignalConnect(ENTOutputSeparator, "activate", quote({
	text <- ENTOutputSeparator$getText()
	SETDataOutput$separator <- text
}))

####
#### Signal: decimal Separator entered
######################################
gSignalConnect(ENTOutputDecimal, "activate", quote({
	text <- ENTOutputDecimal$getText()
	SETDataOutput$decimal <- text
}))

#########################################################################################
#### Data output execute
#########################################################################################

#### Create Execute button
btnDataOutputExecute <- gtkButton("Export Files")
	BXOutputExecute$packEnd(btnDataOutputExecute, expand = FALSE, fill = FALSE)

#### Create vector containing all elements to be activated before execution
CheckInputDataOutput <- c(ENTOutputSeparator, ENTOutputDecimal)

## Errormessage for missing filenames
ERROutFilename <- gtkLabel("-- Please enter proper filenames for all the data sets to be exported! --")
ERROutFilename["visible"] <- FALSE
	BXErrormessages$packStart(ERROutFilename, expand = TRUE, fill = TRUE)

####
#### Signal: Export files button clicked
########################################
gSignalConnect(btnDataOutputExecute, "clicked", quote({
	#### Activate Input for Data Output
	FCheckDataOutput(CheckInputDataOutput)
	
	if (ERROutFilename["visible"] == TRUE) {
		POPExportFail <- gtkMessageDialog(mainApplication, "destroy-with-parent", "error", "ok", "Please solve all status messages and try again.")
		if (POPExportFail$run() == GtkResponseType["ok"]) POPExportFail$destroy()
	} else {
		POPExportRunning <- gtkMessageDialog(mainApplication, "destroy-with-parent", "message", "none", "Exporting files(s) ...")
		Sys.sleep(.1)
		for (i in 1:length(ListOutputLayouts)) {
			if (SETDataOutput$export[names(ListOutputLayouts[i])] == TRUE && FCheckFileExistance(paste(SETDataOutput$folder, SETDataOutput$filenames[names(ListOutputLayouts[i])], sep = "/")) == TRUE) {
				print(paste(getwd(), SETDataOutput$folder, SETDataOutput$filenames[names(ListOutputLayouts[i])], sep="/"))
				output <- file(paste(getwd(), SETDataOutput$folder, SETDataOutput$filenames[names(ListOutputLayouts[i])], sep="/"), open ="w")
				write.table(get(names(ListOutputLayouts[i])), file = output, sep = SETDataOutput$separator, dec = SETDataOutput$decimal, col.names = TRUE, row.names = FALSE)
				close(output)
			}
		}
		
		POPExportRunning["text"] <- "Export finished."
		POPExportRunning$addButton("Close", 1)
		if (POPExportRunning$run() == 1) POPExportRunning$destroy()
		else POPExportRunning$destroy()
	}
}))