SETDataLayout$Version <- "4.0.full"

#########################################################################################
#### Data Input
#########################################################################################

######################
#### Data input layout
######################

####
#### Data Layout Frame
######################

SEPDataLayoutTime <- gtkLabel("")
BXDataLayoutUnitLabel <- gtkHBox(FALSE, 5)
BXDataLayoutUnit <- gtkHBox(FALSE, 5)
	BXLayout$packStart(SEPDataLayoutTime, expand = FALSE, fill = FALSE)
	BXLayout$packStart(BXDataLayoutUnitLabel, expand = FALSE, fill = FALSE)
	BXLayout$packStart(BXDataLayoutUnit, expand = FALSE, fill = FALSE)

## Data Layout measured unit
LBLDataLayoutUnit <- gtkLabel("What did you measure?")
	BXDataLayoutUnitLabel$packStart(LBLDataLayoutUnit, expand = FALSE, fill = FALSE)
	
btnDataLayoutUnitOxoDish <- gtkRadioButton(group = NULL, "PreSens OxoDish")
btnDataLayoutUnitOxoPlate <- gtkRadioButton(group = c(btnDataLayoutUnitOxoDish), "PreSens OxoPlate")
btnDataLayoutUnitHydroPlate <- gtkRadioButton(group = c(btnDataLayoutUnitOxoDish), "PreSens HydroPlate")
btnDataLayoutUnitElse <- gtkRadioButton(group = c(btnDataLayoutUnitOxoDish), "other")
	BXDataLayoutUnit$packStart(btnDataLayoutUnitOxoDish, expand = FALSE, fill = FALSE)
	BXDataLayoutUnit$packStart(btnDataLayoutUnitOxoPlate, expand = FALSE, fill = FALSE)
	BXDataLayoutUnit$packStart(btnDataLayoutUnitHydroPlate, expand = FALSE, fill = FALSE)
	BXDataLayoutUnit$packStart(btnDataLayoutUnitElse, expand = FALSE, fill = FALSE)

###########################
#### Data input interactive
###########################

####
#### Signal: Choice for measured parameter
##########################################
####
#### Function: Setting for measurement output
#############################################
FOutputMeasurement <- function() {
	if (btnDataLayoutUnitOxoDish$getActive() == TRUE) {
		SETDataLayout$inputunit <<- "OD"
		ENTPlotAxesH5$setText("Oxygen level [% air saturation]")
		BXSelectionOxoDish["visible"] <- TRUE
		SEPSelection1["visible"] <- TRUE
		BXSelectionOxoPlate["visible"] <- FALSE
		SEPSelection2["visible"] <- FALSE
		BXSelectionMedium["visible"] <- TRUE
		SEPSelection3["visible"] <- TRUE
		BXSelectionHydroPlate["visible"] <- FALSE
		SEPSelection4["visible"] <- FALSE
		BXPlotAxesH4["visible"] <- TRUE
		FRCons["visible"] <- TRUE
		BXSelectionCons["visible"] <- TRUE
		btnSwitchCalibration["visible"] <- TRUE
		SETAnalysisOpt$oxoDish <<- c(TRUE, FALSE)
		SETAnalysisOpt$oxoPlate <<- c(FALSE, FALSE)
		SETAnalysisOpt$hydroPlate <<- c(FALSE, FALSE)
		SETAnalysisOpt$medium <<- c(TRUE, FALSE)
		Sys.sleep(.1)
		FTranslateSettingsAnalysisOpt(SETAnalysisOpt)
	} else if (btnDataLayoutUnitOxoPlate$getActive() == TRUE) {
		SETDataLayout$inputunit <<- "OP"
		ENTPlotAxesH5$setText("Relative intensity [ratio]")
		BXSelectionOxoDish["visible"] <- FALSE
		SEPSelection1["visible"] <- FALSE
		BXSelectionOxoPlate["visible"] <- TRUE
		SEPSelection2["visible"] <- TRUE
		BXSelectionMedium["visible"] <- FALSE
		SEPSelection3["visible"] <- FALSE
		BXSelectionHydroPlate["visible"] <- FALSE
		SEPSelection4["visible"] <- FALSE
		BXPlotAxesH4["visible"] <- FALSE
		FRCons["visible"] <- TRUE
		BXSelectionCons["visible"] <- TRUE
		btnSwitchCalibration["visible"] <- TRUE
		SETAnalysisOpt$oxoDish <<- c(FALSE, FALSE)
		SETAnalysisOpt$oxoPlate <<- c(TRUE, FALSE)
		SETAnalysisOpt$hydroPlate <<- c(FALSE, FALSE)
		SETAnalysisOpt$medium <<- c(FALSE, FALSE)
		Sys.sleep(.1)
		FTranslateSettingsAnalysisOpt(SETAnalysisOpt)
	} else if (btnDataLayoutUnitHydroPlate$getActive() == TRUE) {
		SETDataLayout$inputunit <<- "HP"
		ENTPlotAxesH5$setText("Relative intensity [ratio]")
		BXSelectionOxoDish["visible"] <- FALSE
		SEPSelection1["visible"] <- FALSE
		BXSelectionOxoPlate["visible"] <- FALSE
		SEPSelection2["visible"] <- FALSE
		BXSelectionMedium["visible"] <- FALSE
		SEPSelection3["visible"] <- FALSE
		BXSelectionHydroPlate["visible"] <- TRUE
		SEPSelection4["visible"] <- TRUE
		BXPlotAxesH4["visible"] <- FALSE
		FRCons["visible"] <- FALSE
		BXSelectionCons["visible"] <- FALSE
		btnSwitchCalibration["visible"] <- FALSE
		SETAnalysisOpt$ConsParam["calc"] <<- FALSE
		SETAnalysisOpt$oxoDish <<- c(FALSE, FALSE)
		SETAnalysisOpt$oxoPlate <<- c(FALSE, FALSE)
		SETAnalysisOpt$hydroPlate <<- c(TRUE, FALSE)
		SETAnalysisOpt$medium <<- c(FALSE, FALSE)
		Sys.sleep(.1)
		FTranslateSettingsAnalysisOpt(SETAnalysisOpt)
	} else if (btnDataLayoutUnitElse$getActive() == TRUE) {
		SETDataLayout$inputunit <<- "none"
		ENTPlotAxesH5$setText("Measured parameter []")
		BXSelectionOxoDish["visible"] <- FALSE
		SEPSelection1["visible"] <- FALSE
		BXSelectionOxoPlate["visible"] <- FALSE
		SEPSelection2["visible"] <- FALSE
		BXSelectionMedium["visible"] <- TRUE
		SEPSelection3["visible"] <- TRUE
		BXSelectionHydroPlate["visible"] <- FALSE
		SEPSelection4["visible"] <- FALSE
		BXPlotAxesH4["visible"] <- TRUE
		FRCons["visible"] <- TRUE
		BXSelectionCons["visible"] <- TRUE
		btnSwitchCalibration["visible"] <- TRUE
		SETAnalysisOpt$oxoDish <<- c(FALSE, FALSE)
		SETAnalysisOpt$oxoPlate <<- c(FALSE, FALSE)
		SETAnalysisOpt$hydroPlate <<- c(FALSE, FALSE)
		SETAnalysisOpt$medium <<- c(TRUE, FALSE)
		Sys.sleep(.1)
		FTranslateSettingsAnalysisOpt(SETAnalysisOpt)
	}
	#print(SETGraphOpt$YScale)
}

gSignalConnect(btnDataLayoutUnitOxoDish, "toggled", quote(FOutputMeasurement()))
gSignalConnect(btnDataLayoutUnitOxoPlate, "toggled", quote(FOutputMeasurement()))
gSignalConnect(btnDataLayoutUnitHydroPlate, "toggled", quote(FOutputMeasurement()))
gSignalConnect(btnDataLayoutUnitElse, "toggled", quote(FOutputMeasurement()))

#########################################################################################
#### Graph Options
#########################################################################################
						
#########################
#### Graph Options layout
#########################

####
#### General Frame
##################

BXPlotGeneralSubOxoDish <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoDishOrig <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoDishSm <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoDishSlope <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoDishCons <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoDishAv <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoDishAvSm <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoDishAvSlope <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoDishAvCons <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoPlate <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoPlateOrig <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoPlateSm <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoPlateSlope <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoPlateCons <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoPlateAv <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoPlateAvSm <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoPlateAvSlope <- gtkHBox(FALSE, 5)
BXPlotGeneralSubOxoPlateAvCons <- gtkHBox(FALSE, 5)
BXPlotGeneralSubHydroPlate <- gtkHBox(FALSE, 5)
BXPlotGeneralSubHydroPlateOrig <- gtkHBox(FALSE, 5)
BXPlotGeneralSubHydroPlateCal <- gtkHBox(FALSE, 5)
BXPlotGeneralSubHydroPlateSm <- gtkHBox(FALSE, 5)
BXPlotGeneralSubHydroPlateSlope <- gtkHBox(FALSE, 5)
BXPlotGeneralSubHydroPlateAv <- gtkHBox(FALSE, 5)
BXPlotGeneralSubHydroPlateAvSm <- gtkHBox(FALSE, 5)
BXPlotGeneralSubHydroPlateAvSlope <- gtkHBox(FALSE, 5)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoDish, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoDishOrig, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoDishSm, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoDishSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoDishCons, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoDishAv, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoDishAvSm, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoDishAvSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoDishAvCons, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoPlate, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoPlateOrig, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoPlateSm, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoPlateSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoPlateCons, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoPlateAv, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoPlateAvSm, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoPlateAvSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubOxoPlateAvCons, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubHydroPlate, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubHydroPlateOrig, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubHydroPlateCal, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubHydroPlateSm, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubHydroPlateSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubHydroPlateAv, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubHydroPlateAvSm, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubHydroPlateAvSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubMedium, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubMediumOrig, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubMediumSm, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubMediumSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubMediumCons, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubMediumAv, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubMediumAvSm, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubMediumAvSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubMediumAvCons, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubIC50Time, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubIC50Fits, expand = FALSE, fill = FALSE)

## Subs OxoDish
LBLSubOxoDish <- gtkLabel("OxoDish calibration:")
LBLSubOxoDish$setSizeRequest(250, -1)
ENTSubOxoDish <- gtkEntry()
ENTSubOxoDish$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoDish$packStart(LBLSubOxoDish, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoDish$packStart(ENTSubOxoDish, expand = TRUE, fill = TRUE)
LBLSubOxoDishOrig <- gtkLabel("Unformatted OxoDish calibration:")
LBLSubOxoDishOrig$setSizeRequest(250, -1)
ENTSubOxoDishOrig <- gtkEntry()
ENTSubOxoDishOrig$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoDishOrig$packStart(LBLSubOxoDishOrig, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoDishOrig$packStart(ENTSubOxoDishOrig, expand = TRUE, fill = TRUE)
LBLSubOxoDishSm <- gtkLabel("Smoothed OxoDish calibration:")
LBLSubOxoDishSm$setSizeRequest(250, -1)
ENTSubOxoDishSm <- gtkEntry()
ENTSubOxoDishSm$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoDishSm$packStart(LBLSubOxoDishSm, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoDishSm$packStart(ENTSubOxoDishSm, expand = TRUE, fill = TRUE)
LBLSubOxoDishSlope <- gtkLabel("Slope of OxoDish calibration:")
LBLSubOxoDishSlope$setSizeRequest(250, -1)
ENTSubOxoDishSlope <- gtkEntry()
ENTSubOxoDishSlope$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoDishSlope$packStart(LBLSubOxoDishSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoDishSlope$packStart(ENTSubOxoDishSlope, expand = TRUE, fill = TRUE)
LBLSubOxoDishCons <- gtkLabel("Consumption from OxoDish calibration:")
LBLSubOxoDishCons$setSizeRequest(250, -1)
ENTSubOxoDishCons <- gtkEntry()
ENTSubOxoDishCons$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoDishCons$packStart(LBLSubOxoDishCons, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoDishCons$packStart(ENTSubOxoDishCons, expand = TRUE, fill = TRUE)

## Subs OxoDish Average
LBLSubOxoDishAv <- gtkLabel("Average OxoDish calibration:")
LBLSubOxoDishAv$setSizeRequest(250, -1)
ENTSubOxoDishAv <- gtkEntry()
ENTSubOxoDishAv$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoDishAv$packStart(LBLSubOxoDishAv, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoDishAv$packStart(ENTSubOxoDishAv, expand = TRUE, fill = TRUE)
LBLSubOxoDishAvSm <- gtkLabel("Smoothed average OxoDish calibration:")
LBLSubOxoDishAvSm$setSizeRequest(250, -1)
ENTSubOxoDishAvSm <- gtkEntry()
ENTSubOxoDishAvSm$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoDishAvSm$packStart(LBLSubOxoDishAvSm, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoDishAvSm$packStart(ENTSubOxoDishAvSm, expand = TRUE, fill = TRUE)
LBLSubOxoDishAvSlope <- gtkLabel("Slope of average OxoDish calibration:")
LBLSubOxoDishAvSlope$setSizeRequest(250, -1)
ENTSubOxoDishAvSlope <- gtkEntry()
ENTSubOxoDishAvSlope$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoDishAvSlope$packStart(LBLSubOxoDishAvSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoDishAvSlope$packStart(ENTSubOxoDishAvSlope, expand = TRUE, fill = TRUE)
LBLSubOxoDishAvCons <- gtkLabel("Consumption from average OxoDish calibration:")
LBLSubOxoDishAvCons$setSizeRequest(250, -1)
ENTSubOxoDishAvCons <- gtkEntry()
ENTSubOxoDishAvCons$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoDishAvCons$packStart(LBLSubOxoDishAvCons, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoDishAvCons$packStart(ENTSubOxoDishAvCons, expand = TRUE, fill = TRUE)

## Subs OxoPlate
LBLSubOxoPlate <- gtkLabel("Converted data:")
LBLSubOxoPlate$setSizeRequest(250, -1)
ENTSubOxoPlate <- gtkEntry()
ENTSubOxoPlate$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoPlate$packStart(LBLSubOxoPlate, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoPlate$packStart(ENTSubOxoPlate, expand = TRUE, fill = TRUE)
LBLSubOxoPlateOrig <- gtkLabel("Unformatted converted data:")
LBLSubOxoPlateOrig$setSizeRequest(250, -1)
ENTSubOxoPlateOrig <- gtkEntry()
ENTSubOxoPlateOrig$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoPlateOrig$packStart(LBLSubOxoPlateOrig, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoPlateOrig$packStart(ENTSubOxoPlateOrig, expand = TRUE, fill = TRUE)
LBLSubOxoPlateSm <- gtkLabel("Smoothed converted data:")
LBLSubOxoPlateSm$setSizeRequest(250, -1)
ENTSubOxoPlateSm <- gtkEntry()
ENTSubOxoPlateSm$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoPlateSm$packStart(LBLSubOxoPlateSm, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoPlateSm$packStart(ENTSubOxoPlateSm, expand = TRUE, fill = TRUE)
LBLSubOxoPlateSlope <- gtkLabel("Slope of converted data:")
LBLSubOxoPlateSlope$setSizeRequest(250, -1)
ENTSubOxoPlateSlope <- gtkEntry()
ENTSubOxoPlateSlope$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoPlateSlope$packStart(LBLSubOxoPlateSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoPlateSlope$packStart(ENTSubOxoPlateSlope, expand = TRUE, fill = TRUE)
LBLSubOxoPlateCons <- gtkLabel("Consumption from converted data:")
LBLSubOxoPlateCons$setSizeRequest(250, -1)
ENTSubOxoPlateCons <- gtkEntry()
ENTSubOxoPlateCons$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoPlateCons$packStart(LBLSubOxoPlateCons, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoPlateCons$packStart(ENTSubOxoPlateCons, expand = TRUE, fill = TRUE)

## Subs OxoPlate Average
LBLSubOxoPlateAv <- gtkLabel("Average converted data:")
LBLSubOxoPlateAv$setSizeRequest(250, -1)
ENTSubOxoPlateAv <- gtkEntry()
ENTSubOxoPlateAv$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoPlateAv$packStart(LBLSubOxoPlateAv, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoPlateAv$packStart(ENTSubOxoPlateAv, expand = TRUE, fill = TRUE)
LBLSubOxoPlateAvSm <- gtkLabel("Smoothed average converted data:")
LBLSubOxoPlateAvSm$setSizeRequest(250, -1)
ENTSubOxoPlateAvSm <- gtkEntry()
ENTSubOxoPlateAvSm$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoPlateAvSm$packStart(LBLSubOxoPlateAvSm, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoPlateAvSm$packStart(ENTSubOxoPlateAvSm, expand = TRUE, fill = TRUE)
LBLSubOxoPlateAvSlope <- gtkLabel("Slope of average converted data:")
LBLSubOxoPlateAvSlope$setSizeRequest(250, -1)
ENTSubOxoPlateAvSlope <- gtkEntry()
ENTSubOxoPlateAvSlope$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoPlateAvSlope$packStart(LBLSubOxoPlateAvSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoPlateAvSlope$packStart(ENTSubOxoPlateAvSlope, expand = TRUE, fill = TRUE)
LBLSubOxoPlateAvCons <- gtkLabel("Consumption from average converted data:")
LBLSubOxoPlateAvCons$setSizeRequest(250, -1)
ENTSubOxoPlateAvCons <- gtkEntry()
ENTSubOxoPlateAvCons$setSizeRequest(-1, 20)
	BXPlotGeneralSubOxoPlateAvCons$packStart(LBLSubOxoPlateAvCons, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubOxoPlateAvCons$packStart(ENTSubOxoPlateAvCons, expand = TRUE, fill = TRUE)

## Subs HydroPlate
LBLSubHydroPlate <- gtkLabel("Converted data:")
LBLSubHydroPlate$setSizeRequest(250, -1)
ENTSubHydroPlate <- gtkEntry()
ENTSubHydroPlate$setSizeRequest(-1, 20)
	BXPlotGeneralSubHydroPlate$packStart(LBLSubHydroPlate, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubHydroPlate$packStart(ENTSubHydroPlate, expand = TRUE, fill = TRUE)
LBLSubHydroPlateOrig <- gtkLabel("Unformatted converted data:")
LBLSubHydroPlateOrig$setSizeRequest(250, -1)
ENTSubHydroPlateOrig <- gtkEntry()
ENTSubHydroPlateOrig$setSizeRequest(-1, 20)
	BXPlotGeneralSubHydroPlateOrig$packStart(LBLSubHydroPlateOrig, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubHydroPlateOrig$packStart(ENTSubHydroPlateOrig, expand = TRUE, fill = TRUE)
LBLSubHydroPlateCal <- gtkLabel("Calibration data for pH conversion:")
LBLSubHydroPlateCal$setSizeRequest(250, -1)
ENTSubHydroPlateCal <- gtkEntry()
ENTSubHydroPlateCal$setSizeRequest(-1, 20)
	BXPlotGeneralSubHydroPlateCal$packStart(LBLSubHydroPlateCal, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubHydroPlateCal$packStart(ENTSubHydroPlateCal, expand = TRUE, fill = TRUE)
LBLSubHydroPlateSm <- gtkLabel("Smoothed converted data:")
LBLSubHydroPlateSm$setSizeRequest(250, -1)
ENTSubHydroPlateSm <- gtkEntry()
ENTSubHydroPlateSm$setSizeRequest(-1, 20)
	BXPlotGeneralSubHydroPlateSm$packStart(LBLSubHydroPlateSm, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubHydroPlateSm$packStart(ENTSubHydroPlateSm, expand = TRUE, fill = TRUE)
LBLSubHydroPlateSlope <- gtkLabel("Slope of converted data:")
LBLSubHydroPlateSlope$setSizeRequest(250, -1)
ENTSubHydroPlateSlope <- gtkEntry()
ENTSubHydroPlateSlope$setSizeRequest(-1, 20)
	BXPlotGeneralSubHydroPlateSlope$packStart(LBLSubHydroPlateSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubHydroPlateSlope$packStart(ENTSubHydroPlateSlope, expand = TRUE, fill = TRUE)

## Subs HydroPlate Average
LBLSubHydroPlateAv <- gtkLabel("Average converted data:")
LBLSubHydroPlateAv$setSizeRequest(250, -1)
ENTSubHydroPlateAv <- gtkEntry()
ENTSubHydroPlateAv$setSizeRequest(-1, 20)
	BXPlotGeneralSubHydroPlateAv$packStart(LBLSubHydroPlateAv, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubHydroPlateAv$packStart(ENTSubHydroPlateAv, expand = TRUE, fill = TRUE)
LBLSubHydroPlateAvSm <- gtkLabel("Smoothed average converted data:")
LBLSubHydroPlateAvSm$setSizeRequest(250, -1)
ENTSubHydroPlateAvSm <- gtkEntry()
ENTSubHydroPlateAvSm$setSizeRequest(-1, 20)
	BXPlotGeneralSubHydroPlateAvSm$packStart(LBLSubHydroPlateAvSm, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubHydroPlateAvSm$packStart(ENTSubHydroPlateAvSm, expand = TRUE, fill = TRUE)
LBLSubHydroPlateAvSlope <- gtkLabel("Slope of average converted data:")
LBLSubHydroPlateAvSlope$setSizeRequest(250, -1)
ENTSubHydroPlateAvSlope <- gtkEntry()
ENTSubHydroPlateAvSlope$setSizeRequest(-1, 20)
	BXPlotGeneralSubHydroPlateAvSlope$packStart(LBLSubHydroPlateAvSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubHydroPlateAvSlope$packStart(ENTSubHydroPlateAvSlope, expand = TRUE, fill = TRUE)

##############################
#### Graph Options interactive
##############################

####
#### Signal: Entry for Subtitles
################################
FCollectSubtitles <- function() {
	SETGraphOpt$Subtitles["raw"] <<- ENTSubRaw$getText()
	SETGraphOpt$Subtitles["rawOrig"] <<- ENTSubRawOrig$getText()
	SETGraphOpt$Subtitles["rawSm"] <<- ENTSubRawSm$getText()
	SETGraphOpt$Subtitles["rawSlope"] <<- ENTSubRawSlope$getText()
	SETGraphOpt$Subtitles["rawCons"] <<- ENTSubRawCons$getText()
	SETGraphOpt$Subtitles["rawAv"] <<- ENTSubRawAv$getText()
	SETGraphOpt$Subtitles["rawAvSm"] <<- ENTSubRawAvSm$getText()
	SETGraphOpt$Subtitles["rawAvSlope"] <<- ENTSubRawAvSlope$getText()
	SETGraphOpt$Subtitles["rawAvCons"] <<- ENTSubRawAvCons$getText()
	SETGraphOpt$Subtitles["oxoDish"] <<- ENTSubOxoDish$getText()
	SETGraphOpt$Subtitles["oxoDishOrig"] <<- ENTSubOxoDishOrig$getText()
	SETGraphOpt$Subtitles["oxoDishSm"] <<- ENTSubOxoDishSm$getText()
	SETGraphOpt$Subtitles["oxoDishSlope"] <<- ENTSubOxoDishSlope$getText()
	SETGraphOpt$Subtitles["oxoDishCons"] <<- ENTSubOxoDishCons$getText()
	SETGraphOpt$Subtitles["oxoDishAv"] <<- ENTSubOxoDishAv$getText()
	SETGraphOpt$Subtitles["oxoDishAvSm"] <<- ENTSubOxoDishAvSm$getText()
	SETGraphOpt$Subtitles["oxoDishAvSlope"] <<- ENTSubOxoDishAvSlope$getText()
	SETGraphOpt$Subtitles["oxoDishAvCons"] <<- ENTSubOxoDishAvCons$getText()
	SETGraphOpt$Subtitles["oxoPlate"] <<- ENTSubOxoPlate$getText()
	SETGraphOpt$Subtitles["oxoPlateOrig"] <<- ENTSubOxoPlateOrig$getText()
	SETGraphOpt$Subtitles["oxoPlateSm"] <<- ENTSubOxoPlateSm$getText()
	SETGraphOpt$Subtitles["oxoPlateSlope"] <<- ENTSubOxoPlateSlope$getText()
	SETGraphOpt$Subtitles["oxoPlateCons"] <<- ENTSubOxoPlateCons$getText()
	SETGraphOpt$Subtitles["oxoPlateAv"] <<- ENTSubOxoPlateAv$getText()
	SETGraphOpt$Subtitles["oxoPlateAvSm"] <<- ENTSubOxoPlateAvSm$getText()
	SETGraphOpt$Subtitles["oxoPlateAvSlope"] <<- ENTSubOxoPlateAvSlope$getText()
	SETGraphOpt$Subtitles["oxoPlateAvCons"] <<- ENTSubOxoPlateAvCons$getText()
	SETGraphOpt$Subtitles["hydroPlate"] <<- ENTSubHydroPlate$getText()
	SETGraphOpt$Subtitles["hydroPlateOrig"] <<- ENTSubHydroPlateOrig$getText()
	SETGraphOpt$Subtitles["hydroPlateCal"] <<- ENTSubHydroPlateCal$getText()
	SETGraphOpt$Subtitles["hydroPlateSm"] <<- ENTSubHydroPlateSm$getText()
	SETGraphOpt$Subtitles["hydroPlateSlope"] <<- ENTSubHydroPlateSlope$getText()
	SETGraphOpt$Subtitles["hydroPlateAv"] <<- ENTSubHydroPlateAv$getText()
	SETGraphOpt$Subtitles["hydroPlateAvSm"] <<- ENTSubHydroPlateAvSm$getText()
	SETGraphOpt$Subtitles["hydroPlateAvSlope"] <<- ENTSubHydroPlateAvSlope$getText()
	SETGraphOpt$Subtitles["medium"] <<- ENTSubMedium$getText()
	SETGraphOpt$Subtitles["mediumOrig"] <<- ENTSubMediumOrig$getText()
	SETGraphOpt$Subtitles["mediumSm"] <<- ENTSubMediumSm$getText()
	SETGraphOpt$Subtitles["mediumSlope"] <<- ENTSubMediumSlope$getText()
	SETGraphOpt$Subtitles["mediumCons"] <<- ENTSubMediumCons$getText()
	SETGraphOpt$Subtitles["mediumAv"] <<- ENTSubMediumAv$getText()
	SETGraphOpt$Subtitles["mediumAvSm"] <<- ENTSubMediumAvSm$getText()
	SETGraphOpt$Subtitles["mediumAvSlope"] <<- ENTSubMediumAvSlope$getText()
	SETGraphOpt$Subtitles["mediumAvCons"] <<- ENTSubMediumAvCons$getText()
	SETGraphOpt$Subtitles["IC50Time"] <<- ENTSubIC50Time$getText()
	SETGraphOpt$Subtitles["IC50Fits"] <<- ENTSubIC50Fits$getText()
}

#########################################################################################
#### Analysis Options
#########################################################################################

#### In addition to the settings the known conversion factors for the OxoPlate
## are saved here. The list FactorLists connects the selectable units to a corresponding
## data frame. These six data frames have the temperature as row names and the pressure
## as column names. These table can be extended easily. The only other things to adjust
## in this case are the possible selections in the comboboxes.
FactorOxygenSat <- data.frame(	row.names = c(	"20 C"	, "37 C"),
								"hPa1013" = c(	0.209	, 0.21) )
FactorhPa <- data.frame(	row.names = c(		"20 C"	, "37 C"),
							"hPa1013" = c(		2.074	, 1.99) )
FactorTorr <- data.frame(	row.names = c(		"20 C"	, "37 C"),
							"hPa1013" = c(		1.556	, 1.49) )
FactormgL <- data.frame(	row.names = c(		"20 C"	, "37 C"),
							"hPa1013" = c(		0.0905	, 0.067) )
Factorppm <- data.frame(	row.names = c(		"20 C"	, "37 C"),
							"hPa1013" = c(		0.0905	, 0.067) )
FactormumolL <- data.frame(	row.names = c(		"20 C"	, "37 C"),
							"hPa1013" = c(		2.8295	, 2.1) )
FactorLists <- list(	"[%] oxygen saturation" = FactorOxygenSat,
						"pO2 [hPa]" = FactorhPa,
						"pO2 [Torr]" = FactorTorr,
						"cO2 [mg/L]" = FactormgL,
						"cO2 [ppm]" = Factorppm,
						"cO2 [mumol/L]" = FactormumolL)

############################
#### Analysis Options layout
############################

####
#### Frame Layout
#################
FROxoDishCal <- gtkFrame()
FROxoPlateCal <- gtkFrame()
FRHydroPlateCal <- gtkFrame()

####
#### Notebook for options
#########################
LBLPageOxoDish <- gtkLabel("Sensor correction")
NBAnalysisOptions$appendPage(FROxoDishCal, tab.label = LBLPageOxoDish)
LBLPageOxoPlate <- gtkLabel("OxoPlate conversion")
NBAnalysisOptions$appendPage(FROxoPlateCal, tab.label = LBLPageOxoPlate)
LBLPageHydroPlate <- gtkLabel("HydroPlate conversion")
NBAnalysisOptions$appendPage(FRHydroPlateCal, tab.label = LBLPageHydroPlate)

####
#### Selection Frame
####################

#### Base
SEPSelection1 <- gtkHSeparator()
BXSelectionOxoDish <- gtkHBox(FALSE, 5)
SEPSelection2 <- gtkHSeparator()
BXSelectionOxoPlate <- gtkHBox(FALSE, 5)
SEPSelection4 <- gtkHSeparator()
BXSelectionHydroPlate <- gtkHBox(FALSE, 5)
	BXSelectionBase$packStart(SEPSelection1, expand = FALSE, fill = FALSE)
	BXSelectionBase$packStart(BXSelectionOxoDish, expand = FALSE, fill = FALSE)
	BXSelectionBase$packStart(SEPSelection2, expand = FALSE, fill = FALSE)
	BXSelectionBase$packStart(BXSelectionOxoPlate, expand = FALSE, fill = FALSE)
	BXSelectionBase$packStart(SEPSelection3, expand = FALSE, fill = FALSE)
	BXSelectionBase$packStart(BXSelectionMedium, expand = FALSE, fill = FALSE)
	BXSelectionBase$packStart(SEPSelection4, expand = FALSE, fill = FALSE)
	BXSelectionBase$packStart(BXSelectionHydroPlate, expand = FALSE, fill = FALSE)

## OxoDish Cal
CKBSelectionOxoDish <- gtkCheckButton("Sensor correction")
CKBSelectionOxoDish$setSizeRequest(160, -1)
CKBSelectionOxoDishAv <- gtkCheckButton("calculate average")
CKBSelectionOxoDishAv$setSizeRequest(150, -1)
	BXSelectionOxoDish$packStart(CKBSelectionOxoDish, expand = FALSE, fill = FALSE)
	BXSelectionOxoDish$packStart(CKBSelectionOxoDishAv, expand = FALSE, fill = FALSE)

## OxoPlate Cal
CKBSelectionOxoPlate <- gtkCheckButton("OxoPlate conversion")
CKBSelectionOxoPlate$setSizeRequest(160, -1)
CKBSelectionOxoPlateAv <- gtkCheckButton("calculate average")
CKBSelectionOxoPlateAv$setSizeRequest(150, -1)
	BXSelectionOxoPlate$packStart(CKBSelectionOxoPlate, expand = FALSE, fill = FALSE)
	BXSelectionOxoPlate$packStart(CKBSelectionOxoPlateAv, expand = FALSE, fill = FALSE)

## HydroPlate Cal
CKBSelectionHydroPlate <- gtkCheckButton("HydroPlate conversion")
CKBSelectionHydroPlate$setSizeRequest(160, -1)
CKBSelectionHydroPlateAv <- gtkCheckButton("calculate average")
CKBSelectionHydroPlateAv$setSizeRequest(150, -1)
	BXSelectionHydroPlate$packStart(CKBSelectionHydroPlate, expand = FALSE, fill = FALSE)
	BXSelectionHydroPlate$packStart(CKBSelectionHydroPlateAv, expand = FALSE, fill = FALSE)

####
#### OxoDish Cal Frame
######################

BXOxoDishCal <- gtkVBox(FALSE, 5)
BXOxoDishCal$setBorderWidth(5)
FROxoDishCal$setBorderWidth(3)
	FROxoDishCal$add(BXOxoDishCal)

BXOxoDishCalLabel <- gtkHBox(FALSE, 5)
BXOxoDishCalSet <- gtkHBox(FALSE, 5)
BXOxoDishCalTarget <- gtkHBox(FALSE, 5)
BXOxoDishCalValues <- gtkHBox(FALSE, 5)
BXOxoDishCalRerun <- gtkHBox(FALSE, 5)
BXOxoDishCalRerun$setBorderWidth(5)
	BXOxoDishCal$packStart(BXOxoDishCalLabel, expand = FALSE, fill = FALSE)
	BXOxoDishCal$packStart(BXOxoDishCalSet, expand = FALSE, fill = FALSE)
	BXOxoDishCal$packStart(BXOxoDishCalTarget, expand = FALSE, fill = FALSE)
	BXOxoDishCal$packStart(BXOxoDishCalValues, expand = FALSE, fill = FALSE)
	BXOxoDishCal$packEnd(BXOxoDishCalRerun, expand = FALSE, fill = FALSE)

## Label
LBLOxoDishCal <- gtkLabel("Please adjust the time frame for the sensor correction.")
	BXOxoDishCalLabel$packStart(LBLOxoDishCal, expand = FALSE, fill = FALSE)

## Set
LBLOxoDishCal1 <- gtkLabel("Use")
ENTOxoDishCalNumber <- gtkEntry()
ENTOxoDishCalNumber$setSizeRequest(40, 20)
LBLOxoDishCal2 <- gtkLabel("time points where the last included one is at t =")
ENTOxoDishCalLast <- gtkEntry()
ENTOxoDishCalLast$setSizeRequest(40, 20)
LBLOxoDishCal3 <- gtkLabel("in the given input unit.")
	BXOxoDishCalSet$packStart(LBLOxoDishCal1, expand = FALSE, fill = FALSE)
	BXOxoDishCalSet$packStart(ENTOxoDishCalNumber, expand = FALSE, fill = FALSE)
	BXOxoDishCalSet$packStart(LBLOxoDishCal2, expand = FALSE, fill = FALSE)
	BXOxoDishCalSet$packStart(ENTOxoDishCalLast, expand = FALSE, fill = FALSE)
	BXOxoDishCalSet$packStart(LBLOxoDishCal3, expand = FALSE, fill = FALSE)

## Target
LBLOxoDishCalTarget <- gtkLabel("What is the target value for the sensor correction in % air saturation?")
ENTOxoDishCalTarget <- gtkEntry()
ENTOxoDishCalTarget$setSizeRequest(50, 20)
	BXOxoDishCalTarget$packStart(LBLOxoDishCalTarget, expand = FALSE, fill = FALSE)
	BXOxoDishCalTarget$packStart(ENTOxoDishCalTarget, expand = FALSE, fill = FALSE)

## Values
LBLOxoDishCalSpan <- gtkLabel("Span:")
ENTOxoDishCalSpan <- gtkEntry()
ENTOxoDishCalSpan$setSizeRequest(50, 20)
LBLOxoDishCalPlateau <- gtkLabel("Plateau:")
ENTOxoDishCalPlateau <- gtkEntry()
ENTOxoDishCalPlateau$setSizeRequest(50, 20)
	BXOxoDishCalValues$packStart(LBLOxoDishCalSpan, expand = FALSE, fill = FALSE)
	BXOxoDishCalValues$packStart(ENTOxoDishCalSpan, expand = FALSE, fill = FALSE)
	BXOxoDishCalValues$packStart(LBLOxoDishCalPlateau, expand = FALSE, fill = FALSE)
	BXOxoDishCalValues$packStart(ENTOxoDishCalPlateau, expand = FALSE, fill = FALSE)

## Rerun
btnOxoDishCalRerun <- gtkButton("Rerun OxoDish correction only")
btnOxoDishCalRerun$setSizeRequest(250, 30)
btnOxoDishCalRerun["visible"] <- FALSE
	BXOxoDishCalRerun$packStart(btnOxoDishCalRerun, expand = TRUE, fill = FALSE)

####
#### OxoPlate conversion
########################

BXOxoPlateCal <- gtkVBox(FALSE, 5)
BXOxoPlateCal$setBorderWidth(5)
FROxoPlateCal$setBorderWidth(3)
	FROxoPlateCal$add(BXOxoPlateCal)

BXOxoPlateCal0 <- gtkHBox(FALSE, 5)
BXOxoPlateCal100 <- gtkHBox(FALSE, 5)
BXOxoPlateCalT1 <- gtkHBox(FALSE, 5)
BXOxoPlateCalT2 <- gtkHBox(FALSE, 5)
BXOxoPlateCalT3 <- gtkHBox(FALSE, 5)
BXOxoPlateCalRerun <- gtkHBox(FALSE, 5)
BXOxoPlateCalRerun$setBorderWidth(5)
	BXOxoPlateCal$packStart(BXOxoPlateCal0, expand = FALSE, fill = FALSE)
	BXOxoPlateCal$packStart(BXOxoPlateCal100, expand = FALSE, fill = FALSE)
	BXOxoPlateCal$packStart(BXOxoPlateCalT1, expand = FALSE, fill = FALSE)
	BXOxoPlateCal$packStart(BXOxoPlateCalT2, expand = FALSE, fill = FALSE)
	BXOxoPlateCal$packStart(BXOxoPlateCalT3, expand = FALSE, fill = FALSE)
	BXOxoPlateCal$packEnd(BXOxoPlateCalRerun, expand = FALSE, fill = FALSE)

## cal 0
LBLOxoPlateCal0 <- gtkLabel("What is the name of the wells containing 0 % oxygen?")
ENTOxoPlateCal0 <- gtkEntry()
ENTOxoPlateCal0$setSizeRequest(-1, 20)
	BXOxoPlateCal0$packStart(LBLOxoPlateCal0, expand = FALSE, fill = FALSE)
	BXOxoPlateCal0$packStart(ENTOxoPlateCal0, expand = TRUE, fill = TRUE)

## cal 100
LBLOxoPlateCal100 <- gtkLabel("What is the name of the wells containing 100 % oxygen?")
ENTOxoPlateCal100 <- gtkEntry()
ENTOxoPlateCal100$setSizeRequest(-1, 20)
	BXOxoPlateCal100$packStart(LBLOxoPlateCal100, expand = FALSE, fill = FALSE)
	BXOxoPlateCal100$packStart(ENTOxoPlateCal100, expand = TRUE, fill = TRUE)

## Target Unit
LBLOxoPlateCalT1 <- gtkLabel("Please choose the target unit, pressure and temperature, or choose 'other' for any of them and enter the conversion factor.")
	BXOxoPlateCalT1$packStart(LBLOxoPlateCalT1, expand = FALSE, fill = FALSE)

LBLOxoPlateCalT2 <- gtkLabel("Target unit:")
COMOxoPlateCalTargetUnit <- gtkComboBoxNewText()
	COMOxoPlateCalTargetUnit$appendText("[%] oxygen saturation")
	COMOxoPlateCalTargetUnit$appendText("pO2 [hPa]")
	COMOxoPlateCalTargetUnit$appendText("pO2 [Torr]")
	COMOxoPlateCalTargetUnit$appendText("cO2 [mg/L]")
	COMOxoPlateCalTargetUnit$appendText("cO2 [ppm]")
	COMOxoPlateCalTargetUnit$appendText("cO2 [mumol/L]")
	COMOxoPlateCalTargetUnit$appendText("other")
	COMOxoPlateCalTargetUnit$setActive(0)
	BXOxoPlateCalT2$packStart(LBLOxoPlateCalT2, expand = FALSE, fill = FALSE)
	BXOxoPlateCalT2$packStart(COMOxoPlateCalTargetUnit, expand = FALSE, fill = FALSE)

LBLOxoPlateCalTPres <- gtkLabel("Pressure:")
COMOxoPlateCalTPres <- gtkComboBoxNewText()
	COMOxoPlateCalTPres$appendText("1013 hPa")
	COMOxoPlateCalTPres$appendText("other")
	COMOxoPlateCalTPres$setActive(0)
LBLOxoPlateCalTTemp <- gtkLabel("Temperature:")
COMOxoPlateCalTTemp <- gtkComboBoxNewText()
	COMOxoPlateCalTTemp$appendText("20 C")
	COMOxoPlateCalTTemp$appendText("37 C")
	COMOxoPlateCalTTemp$appendText("other")
	COMOxoPlateCalTTemp$setActive(0)
ENTOxoPlateCalTfactor <- gtkEntry()
ENTOxoPlateCalTfactor$setSizeRequest(60, 20)
	BXOxoPlateCalT3$packStart(LBLOxoPlateCalTPres, expand = FALSE, fill = FALSE)
	BXOxoPlateCalT3$packStart(COMOxoPlateCalTPres, expand = FALSE, fill = FALSE)
	BXOxoPlateCalT3$packStart(LBLOxoPlateCalTTemp, expand = FALSE, fill = FALSE)
	BXOxoPlateCalT3$packStart(COMOxoPlateCalTTemp, expand = FALSE, fill = FALSE)
	BXOxoPlateCalT3$packStart(ENTOxoPlateCalTfactor, expand = FALSE, fill = FALSE)

## Rerun
btnOxoPlateCalRerun <- gtkButton("Rerun OxoPlate conversion only")
btnOxoPlateCalRerun$setSizeRequest(250, 30)
btnOxoPlateCalRerun["visible"] <- FALSE
	BXOxoPlateCalRerun$packStart(btnOxoPlateCalRerun, expand = TRUE, fill = FALSE)

####
#### HydroPlate Frame
#####################

BXHydroPlateCal <- gtkVBox(FALSE, 5)
BXHydroPlateCal$setBorderWidth(5)
FRHydroPlateCal$setBorderWidth(3)
	FRHydroPlateCal$add(BXHydroPlateCal)

LBLHydroPlateCal <- gtkLabel("Please enter the pH values of the calibration wells (by name) and -1 for all the others.")
BXHydroPlateCalRerun <- gtkHBox(FALSE, 5)
	BXHydroPlateCal$packStart(LBLHydroPlateCal, expand = FALSE, fill = FALSE)
	BXHydroPlateCal$packEnd(BXHydroPlateCalRerun, expand = FALSE, fill = FALSE)
	
TEMPpHs <- list()

## Rerun
btnHydroPlateCalRerun <- gtkButton("Rerun HydroPlate conversion only")
btnHydroPlateCalRerun$setSizeRequest(250, 30)
btnHydroPlateCalRerun["visible"] <- FALSE
	BXHydroPlateCalRerun$packStart(btnHydroPlateCalRerun, expand = TRUE, fill = FALSE)

####
#### Function: Refresh lines on HydroPlate screen
#################################################
FRefreshHydropHs <- function(T) {
	
	oldpHs <- BXHydroPlateCal$getChildren()
	if (length(oldpHs) >= 3) {
		FCheckHydropHs(Template)
		for (i in 2:(length(oldpHs)-1)) {
			gtkWidgetDestroy(oldpHs[[i]])
		}
	}
	
	pHs <- c()
	names <- levels(as.factor(T$Name))
	
	TEMPpHs <<- list()
	for (i in 1:length(names)) {
		TEMPpHs[[names[i]]] <<- list()
		TEMPpHs[[names[i]]]$box <<- gtkHBox(FALSE, 5)
		TEMPpHs[[names[i]]]$label <<- gtkLabel(paste(names[i], ":", sep=""))
		gtkWidgetSetSizeRequest(TEMPpHs[[names[i]]]$label, 100, 20)		
		TEMPpHs[[names[i]]]$entry <<- gtkEntry()
		gtkEntrySetText(TEMPpHs[[names[i]]]$entry, tryCatch(as.numeric(names[i]), warning = function(W) return(-1)))
		if (length(which(SETAnalysisOpt$hydroPlateCal$Name == names[i])) >= 1) gtkEntrySetText(TEMPpHs[[names[i]]]$entry, SETAnalysisOpt$hydroPlateCal$pH[which(SETAnalysisOpt$hydroPlateCal$Name == names[i])])
		gtkWidgetSetSizeRequest(TEMPpHs[[names[i]]]$entry, 50, 20)
			gtkBoxPackStart(TEMPpHs[[names[i]]]$box, TEMPpHs[[names[i]]]$label, expand = FALSE, fill = FALSE)
			gtkBoxPackStart(TEMPpHs[[names[i]]]$box, TEMPpHs[[names[i]]]$entry, expand = FALSE, fill = FALSE)
			BXHydroPlateCal$packStart(TEMPpHs[[names[i]]]$box, expand = FALSE, fill = FALSE)
		pH <- as.numeric(gtkEntryGetText(TEMPpHs[[names[i]]]$entry))
		pHs <- c(pHs, pH)
	}
	
	SETAnalysisOpt$hydroPlateCal <<- data.frame(Name = names, pH = pHs)
}

####
#### Function: Load Template including HydroPlate Refresh
#########################################################
FLoadTemplate <- function(path, separator) {
	Template <<- read.table(path, header = TRUE, sep = separator, colClasses = "character")
	names(Template)[1] <- "X"
	if (FCheckTemplateLoaded(Template) == TRUE) {
		FTemplateTableRestore(Template)
	}
	FRefreshIC50Doses(Template)
	FRefreshHydropHs(Template)
}

####
#### Smooth Frame
#################

BXSmoothOxoDish <- gtkHBox(FALSE, 5)
BXSmoothOxoDishAv <- gtkHBox(FALSE, 5)
BXSmoothOxoPlate <- gtkHBox(FALSE, 5)
BXSmoothOxoPlateAv <- gtkHBox(FALSE, 5)
BXSmoothHydroPlate <- gtkHBox(FALSE, 5)
BXSmoothHydroPlateAv <- gtkHBox(FALSE, 5)
	BXSmooth$packStart(BXSmoothOxoDish, expand = FALSE, fill = FALSE)
	BXSmooth$packStart(BXSmoothOxoDishAv, expand = FALSE, fill = FALSE)
	BXSmooth$packStart(BXSmoothOxoPlate, expand = FALSE, fill = FALSE)
	BXSmooth$packStart(BXSmoothOxoPlateAv, expand = FALSE, fill = FALSE)
	BXSmooth$packStart(BXSmoothHydroPlate, expand = FALSE, fill = FALSE)
	BXSmooth$packStart(BXSmoothHydroPlateAv, expand = FALSE, fill = FALSE)
	BXSmooth$packStart(BXSmoothMedium, expand = FALSE, fill = FALSE)
	BXSmooth$packStart(BXSmoothMediumAv, expand = FALSE, fill = FALSE)

## Checkboxes
CKBSmOxoDish <- gtkCheckButton("sensor corrected data")
	BXSmoothOxoDish$packStart(CKBSmOxoDish, expand = FALSE, fill = FALSE)
CKBSmOxoDishAv <- gtkCheckButton("average sensor corrected data")
	BXSmoothOxoDishAv$packStart(CKBSmOxoDishAv, expand = FALSE, fill = FALSE)
CKBSmOxoPlate <- gtkCheckButton("converted data")
	BXSmoothOxoPlate$packStart(CKBSmOxoPlate, expand = FALSE, fill = FALSE)
CKBSmOxoPlateAv <- gtkCheckButton("average converted data")
	BXSmoothOxoPlateAv$packStart(CKBSmOxoPlateAv, expand = FALSE, fill = FALSE)
CKBSmHydroPlate <- gtkCheckButton("converted data")
	BXSmoothHydroPlate$packStart(CKBSmHydroPlate, expand = FALSE, fill = FALSE)
CKBSmHydroPlateAv <- gtkCheckButton("average converted data")
	BXSmoothHydroPlateAv$packStart(CKBSmHydroPlateAv, expand = FALSE, fill = FALSE)

####
#### Numerical slope Frame
##########################

BXSlopeOxoDish <- gtkHBox(FALSE, 5)
BXSlopeOxoDishAv <- gtkHBox(FALSE, 5)
BXSlopeOxoPlate <- gtkHBox(FALSE, 5)
BXSlopeOxoPlateAv <- gtkHBox(FALSE, 5)
BXSlopeHydroPlate <- gtkHBox(FALSE, 5)
BXSlopeHydroPlateAv <- gtkHBox(FALSE, 5)
	BXSlope$packStart(BXSlopeOxoDish, expand = FALSE, fill = FALSE)
	BXSlope$packStart(BXSlopeOxoDishAv, expand = FALSE, fill = FALSE)
	BXSlope$packStart(BXSlopeOxoPlate, expand = FALSE, fill = FALSE)
	BXSlope$packStart(BXSlopeOxoPlateAv, expand = FALSE, fill = FALSE)
	BXSlope$packStart(BXSlopeHydroPlate, expand = FALSE, fill = FALSE)
	BXSlope$packStart(BXSlopeHydroPlateAv, expand = FALSE, fill = FALSE)
	BXSlope$packStart(BXSlopeMedium, expand = FALSE, fill = FALSE)
	BXSlope$packStart(BXSlopeMediumAv, expand = FALSE, fill = FALSE)

## Checkboxes
CKBSlopeOxoDish <- gtkCheckButton("sensor corrected data")
	BXSlopeOxoDish$packStart(CKBSlopeOxoDish, expand = FALSE, fill = FALSE)
CKBSlopeOxoDishAv <- gtkCheckButton("Average sensor corrected data")
	BXSlopeOxoDishAv$packStart(CKBSlopeOxoDishAv, expand = FALSE, fill = FALSE)
CKBSlopeOxoPlate <- gtkCheckButton("converted data")
	BXSlopeOxoPlate$packStart(CKBSlopeOxoPlate, expand = FALSE, fill = FALSE)
CKBSlopeOxoPlateAv <- gtkCheckButton("average converted data")
	BXSlopeOxoPlateAv$packStart(CKBSlopeOxoPlateAv, expand = FALSE, fill = FALSE)
CKBSlopeHydroPlate <- gtkCheckButton("converted data")
	BXSlopeHydroPlate$packStart(CKBSlopeHydroPlate, expand = FALSE, fill = FALSE)
CKBSlopeHydroPlateAv <- gtkCheckButton("average converted data")
	BXSlopeHydroPlateAv$packStart(CKBSlopeHydroPlateAv, expand = FALSE, fill = FALSE)

####
#### Consumption Frame
######################

BXConsOxoDish <- gtkHBox(FALSE, 5)
BXConsOxoDishAv <- gtkHBox(FALSE, 5)
BXConsOxoPlate <- gtkHBox(FALSE, 5)
BXConsOxoPlateAv <- gtkHBox(FALSE, 5)
	BXCons$packStart(BXConsOxoDish, expand = FALSE, fill = FALSE)
	BXCons$packStart(BXConsOxoDishAv, expand = FALSE, fill = FALSE)
	BXCons$packStart(BXConsOxoPlate, expand = FALSE, fill = FALSE)
	BXCons$packStart(BXConsOxoPlateAv, expand = FALSE, fill = FALSE)
	BXCons$packStart(BXConsMedium, expand = FALSE, fill = FALSE)
	BXCons$packStart(BXConsMediumAv, expand = FALSE, fill = FALSE)

## Sat
btnConsSatOxoDish <- gtkButton("use sensor correction target value")
	BXConsSat$packStart(btnConsSatOxoDish, expand = FALSE, fill = FALSE)
	BXConsSat$packStart(btnConsSatMedium, expand = FALSE, fill = FALSE)

## Checkboxes
CKBConsOxoDish <- gtkCheckButton("sensor corrected data")
	BXConsOxoDish$packStart(CKBConsOxoDish, expand = FALSE, fill = FALSE)
CKBConsOxoDishAv <- gtkCheckButton("average sensor corrected data")
	BXConsOxoDishAv$packStart(CKBConsOxoDishAv, expand = FALSE, fill = FALSE)
CKBConsOxoPlate <- gtkCheckButton("converted data")
	BXConsOxoPlate$packStart(CKBConsOxoPlate, expand = FALSE, fill = FALSE)
CKBConsOxoPlateAv <- gtkCheckButton("average converted data")
	BXConsOxoPlateAv$packStart(CKBConsOxoPlateAv, expand = FALSE, fill = FALSE)

#################################
#### Analysis Options interactive
#################################

####
#### Signal: Calculate Smooth
#############################
gSignalConnect(CKBSelectionSmooth, "toggled", quote({
	if (CKBSelectionSmooth$getActive() == TRUE) {
		FRSmooth["visible"] <- TRUE
		SETAnalysisOpt$smoothParam["calc"] <- TRUE
		if (loading == FALSE) FCheckAnalysisOpt(c(ENTSmoothOption, CKBSmRaw, CKBSmRawAv, CKBSmMedium, CKBSmMediumAv, CKBSmOxoDish, CKBSmOxoDishAv, CKBSmOxoPlate, CKBSmOxoPlateAv, CKBSmHydroPlate, CKBSmHydroPlateAv))
	} else {
		FRSmooth["visible"] <- FALSE
		SETAnalysisOpt$smoothParam["calc"] <- FALSE
		CKBSmRaw$setActive(is.active = FALSE)
		CKBSmRawAv$setActive(is.active = FALSE)
		CKBSmOxoDish$setActive(is.active = FALSE)
		CKBSmOxoDishAv$setActive(is.active = FALSE)
		CKBSmOxoPlate$setActive(is.active = FALSE)
		CKBSmOxoPlateAv$setActive(is.active = FALSE)
		CKBSmHydroPlate$setActive(is.active = FALSE)
		CKBSmHydroPlateAv$setActive(is.active = FALSE)
		CKBSmMedium$setActive(is.active = FALSE)
		CKBSmMediumAv$setActive(is.active = FALSE)
		if (loading == FALSE) FCheckAnalysisOpt(c(ENTSmoothOption, CKBSmRaw, CKBSmRawAv, CKBSmMedium, CKBSmMediumAv, CKBSmOxoDish, CKBSmOxoDishAv, CKBSmOxoPlate, CKBSmOxoPlateAv, CKBSmHydroPlate, CKBSmHydroPlateAv))
	}
}))

####
#### Signal: Calculate Slope
############################
gSignalConnect(CKBSelectionSlope, "toggled", quote({
	if (CKBSelectionSlope$getActive() == TRUE) {
		FRSlope["visible"] <- TRUE
		SETAnalysisOpt$slopeParam["calc"] <- TRUE
		if (loading == FALSE) FCheckAnalysisOpt(c(ENTSlopeSmooth, ENTSlopePoints, CKBSlopeRaw, CKBSlopeRawAv, CKBSlopeMedium, CKBSlopeMediumAv, CKBSlopeOxoDish, CKBSlopeOxoDishAv, CKBSlopeOxoPlate, CKBSlopeOxoPlateAv, CKBSlopeHydroPlate, CKBSlopeHydroPlateAv))
	} else {
		FRSlope["visible"] <- FALSE
		SETAnalysisOpt$slopeParam["calc"] <- FALSE
		CKBSlopeRaw$setActive(is.active = FALSE)
		CKBSlopeRawAv$setActive(is.active = FALSE)
		CKBSlopeOxoDish$setActive(is.active = FALSE)
		CKBSlopeOxoDishAv$setActive(is.active = FALSE)
		CKBSlopeOxoPlate$setActive(is.active = FALSE)
		CKBSlopeOxoPlateAv$setActive(is.active = FALSE)
		CKBSlopeHydroPlate$setActive(is.active = FALSE)
		CKBSlopeHydroPlateAv$setActive(is.active = FALSE)
		CKBSlopeMedium$setActive(is.active = FALSE)
		CKBSlopeMediumAv$setActive(is.active = FALSE)
		if (loading == FALSE) FCheckAnalysisOpt(c(ENTSlopeSmooth, ENTSlopePoints, CKBSlopeRaw, CKBSlopeRawAv, CKBSlopeMedium, CKBSlopeMediumAv, CKBSlopeOxoDish, CKBSlopeOxoDishAv, CKBSlopeOxoPlate, CKBSlopeOxoPlateAv, CKBSlopeHydroPlate, CKBSlopeHydroPlateAv))
	}
}))

####
#### Signal: Calculate Oxygen Consumption
#########################################
gSignalConnect(CKBSelectionCons, "toggled", quote({
	if (CKBSelectionCons$getActive() == TRUE) {
		FRCons["visible"] <- TRUE
		SETAnalysisOpt$ConsParam["calc"] <- TRUE
		if (loading == FALSE) FCheckAnalysisOpt(c(ENTConsSat, ENTConsFactorsKLA, ENTConsFactorsKLAError, ENTConsFactorsUCon, ENTConsAxis, CKBConsRaw, CKBConsRawAv, CKBConsOxoDish, CKBConsOxoDishAv, CKBConsOxoPlate, CKBConsOxoPlateAv, CKBConsMedium, CKBConsMediumAv))
	} else {
		FRCons["visible"] <- FALSE
		SETAnalysisOpt$ConsParam["calc"] <- FALSE
		CKBConsRaw$setActive(is.active = FALSE)
		CKBConsRawAv$setActive(is.active = FALSE)
		CKBConsOxoDish$setActive(is.active = FALSE)
		CKBConsOxoDishAv$setActive(is.active = FALSE)
		CKBConsOxoPlate$setActive(is.active = FALSE)
		CKBConsOxoPlateAv$setActive(is.active = FALSE)
		CKBConsMedium$setActive(is.active = FALSE)
		CKBConsMediumAv$setActive(is.active = FALSE)
		if (loading == FALSE) FCheckAnalysisOpt(c(ENTConsSat, ENTConsFactorsKLA, ENTConsFactorsKLAError, ENTConsFactorsUCon, ENTConsAxis, CKBConsRaw, CKBConsRawAv, CKBConsOxoDish, CKBConsOxoDishAv, CKBConsOxoPlate, CKBConsOxoPlateAv, CKBConsMedium, CKBConsMediumAv))
	}
}))

####
#### Signals: Checkboxes for Smoothing
######################################
gSignalConnect(CKBSmOxoDish, "toggled", after = TRUE, quote(FSignalCheckSmooth(CKB = CKBSmOxoDish, SET = "Data_oxoDish", Sub = BXPlotGeneralSubOxoDishSm, btn = btnOxoDishSmShow, FROut = FROutOxoDishSm)))
gSignalConnect(CKBSmOxoDishAv, "toggled", after = TRUE, quote(FSignalCheckSmooth(CKB = CKBSmOxoDishAv, SET = "Data_oxoDishAv", Sub = BXPlotGeneralSubOxoDishAvSm, btn = btnOxoDishAvSmShow, FROut = FROutOxoDishAvSm)))
gSignalConnect(CKBSmOxoPlate, "toggled", after = TRUE, quote(FSignalCheckSmooth(CKB = CKBSmOxoPlate, SET = "Data_oxoPlate", Sub = BXPlotGeneralSubOxoPlateSm, btn = btnOxoPlateSmShow, FROut = FROutOxoPlateSm)))
gSignalConnect(CKBSmOxoPlateAv, "toggled", after = TRUE, quote(FSignalCheckSmooth(CKB = CKBSmOxoPlateAv, SET = "Data_oxoPlateAv", Sub = BXPlotGeneralSubOxoPlateAvSm, btn = btnOxoPlateAvSmShow, FROut = FROutOxoPlateAvSm)))
gSignalConnect(CKBSmHydroPlate, "toggled", after = TRUE, quote(FSignalCheckSmooth(CKB = CKBSmHydroPlate, SET = "Data_hydroPlate", Sub = BXPlotGeneralSubHydroPlateSm, btn = btnHydroPlateSmShow, FROut = FROutHydroPlateSm)))
gSignalConnect(CKBSmHydroPlateAv, "toggled", after = TRUE, quote(FSignalCheckSmooth(CKB = CKBSmHydroPlateAv, SET = "Data_hydroPlateAv", Sub = BXPlotGeneralSubHydroPlateAvSm, btn = btnHydroPlateAvSmShow, FROut = FROutHydroPlateAvSm)))

####
#### Signals: Checkboxes for Slope
##################################
gSignalConnect(CKBSlopeOxoDish, "toggled", after = TRUE, quote(FSignalCheckSlope(CKB = CKBSlopeOxoDish, SET = "Data_oxoDish", Sub = BXPlotGeneralSubOxoDishSlope, btn = btnOxoDishSlopeShow, FROut = FROutOxoDishSlope, FROutSd = FROutOxoDishSlopeSd, BXCons = BXConsOxoDish, CKBCons = CKBConsOxoDish)))
gSignalConnect(CKBSlopeOxoDishAv, "toggled", after = TRUE, quote(FSignalCheckSlope(CKB = CKBSlopeOxoDishAv, SET = "Data_oxoDishAv", Sub = BXPlotGeneralSubOxoDishAvSlope, btn = btnOxoDishAvSlopeShow, FROut = FROutOxoDishAvSlope, FROutSd = FROutOxoDishAvSlopeSd, BXCons = BXConsOxoDishAv, CKBCons = CKBConsOxoDishAv)))
gSignalConnect(CKBSlopeOxoPlate, "toggled", after = TRUE, quote(FSignalCheckSlope(CKB = CKBSlopeOxoPlate, SET = "Data_oxoPlate", Sub = BXPlotGeneralSubOxoPlateSlope, btn = btnOxoPlateSlopeShow, FROut = FROutOxoPlateSlope, FROutSd = FROutOxoPlateSlopeSd, BXCons = BXConsOxoPlate, CKBCons = CKBConsOxoPlate)))
gSignalConnect(CKBSlopeOxoPlateAv, "toggled", after = TRUE, quote(FSignalCheckSlope(CKB = CKBSlopeOxoPlateAv, SET = "Data_oxoPlateAv", Sub = BXPlotGeneralSubOxoPlateAvSlope, btn = btnOxoPlateAvSlopeShow, FROut = FROutOxoPlateAvSlope, FROutSd = FROutOxoPlateAvSlopeSd, BXCons = BXConsOxoPlateAv, CKBCons = CKBConsOxoPlateAv)))
gSignalConnect(CKBSlopeHydroPlate, "toggled", after = TRUE, quote(FSignalCheckSlope(CKB = CKBSlopeHydroPlate, SET = "Data_hydroPlate", Sub = BXPlotGeneralSubHydroPlateSlope, btn = btnHydroPlateSlopeShow, FROut = FROutHydroPlateSlope, FROutSd = FROutHydroPlateSlopeSd, BXCons = c(), CKBCons = c())))
gSignalConnect(CKBSlopeHydroPlateAv, "toggled", after = TRUE, quote(FSignalCheckSlope(CKB = CKBSlopeHydroPlateAv, SET = "Data_hydroPlateAv", Sub = BXPlotGeneralSubHydroPlateAvSlope, btn = btnHydroPlateAvSlopeShow, FROut = FROutHydroPlateAvSlope, FROutSd = FROutHydroPlateAvSlopeSd, BXCons = c(), CKBCons = c())))

####
#### Signal: Checkboxes for Consumption
#######################################
gSignalConnect(CKBConsOxoDish, "toggled", after = TRUE, quote(FSignalCheckCons(CKB = CKBConsOxoDish, SET = "Data_oxoDish", Sub = BXPlotGeneralSubOxoDishCons, btn = btnOxoDishConsShow, FROut = FROutOxoDishCons, FROutSd = FROutOxoDishConsSd)))
gSignalConnect(CKBConsOxoDishAv, "toggled", after = TRUE, quote(FSignalCheckCons(CKB = CKBConsOxoDishAv, SET = "Data_oxoDishAv", Sub = BXPlotGeneralSubOxoDishAvCons, btn = btnOxoDishAvConsShow, FROut = FROutOxoDishAvCons, FROutSd = FROutOxoDishAvConsSd)))
gSignalConnect(CKBConsOxoPlate, "toggled", after = TRUE, quote(FSignalCheckCons(CKB = CKBConsOxoPlate, SET = "Data_oxoPlate", Sub = BXPlotGeneralSubOxoPlateCons, btn = btnOxoPlateConsShow, FROut = FROutOxoPlateCons, FROutSd = FROutOxoPlateConsSd)))
gSignalConnect(CKBConsOxoPlateAv, "toggled", after = TRUE, quote(FSignalCheckCons(CKB = CKBConsOxoPlateAv, SET = "Data_oxoPlateAv", Sub = BXPlotGeneralSubOxoPlateAvCons, btn = btnOxoPlateAvConsShow, FROut = FROutOxoPlateAvCons, FROutSd = FROutOxoPlateAvConsSd)))

####
#### Signal: Selection OxoDish cal
##################################
gSignalConnect(CKBSelectionOxoDish, "toggled", quote({
	if (CKBSelectionOxoDish$getActive() == TRUE) {
		## Settings
		SETAnalysisOpt$oxoDish[1] <- TRUE
		TEMPIC50Selection["Data_oxoDish"] <- TRUE
		TEMPFormatSelectData["Data_oxoDish"] <- TRUE
		TEMPFormatSelectData["Data_raw"] <- TRUE
		## Layouts
		BXFormatTransformY["visible"] <- TRUE
		FROxoDishCal["visible"] <- TRUE
		BXSmoothOxoDish["visible"] <- TRUE
		BXSlopeOxoDish["visible"] <- TRUE
		BXConsOxoDish["visible"] <- as.logical(SETAnalysisOpt$slopeSelection["Data_oxoDish"])
		BXPlotGeneralSubOxoDish["visible"] <- TRUE
		FROutOxoDish["visible"] <- TRUE
		FRMiniaturOxoDish["visible"] <- TRUE
		## Restrictions - none
	} else {
		## Settings
		SETAnalysisOpt$oxoDish[1] <- FALSE
		TEMPIC50Selection["Data_oxoDish"] <- FALSE
		TEMPFormatSelectData["Data_oxoDish"] <- FALSE
		## Layouts
		FROxoDishCal["visible"] <- FALSE
		BXSmoothOxoDish["visible"] <- FALSE
		BXSlopeOxoDish["visible"] <- FALSE
		BXConsOxoDish["visible"] <- FALSE
		BXPlotGeneralSubOxoDish["visible"] <- FALSE
		FROutOxoDish["visible"] <- FALSE
		FRMiniaturOxoDish["visible"] <- FALSE
		## Restrictions
		CKBSelectionOxoDishAv$setActive(is.active = FALSE)
		CKBSmOxoDish$setActive(is.active = FALSE)
		CKBSlopeOxoDish$setActive(is.active = FALSE)
		CKBConsOxoDish$setActive(is.active = FALSE)
		ListOutputLayouts[["Data_oxoDish"]][["ckb"]]$setActive(is.active = FALSE)
	}
	FRefreshIC50Selection()
	FRefreshFormattingSelection()
	#print(SETAnalysisOpt$oxoDish)
}))

####
#### Signal: Selection OxoDish cal average
##########################################
gSignalConnect(CKBSelectionOxoDishAv, "toggled", quote({
	if (CKBSelectionOxoDishAv$getActive() == TRUE) {
		## Settings
		SETAnalysisOpt$oxoDish[2] <- TRUE
		TEMPIC50Selection["Data_oxoDishAv"] <- TRUE
		## Layouts
		BXSmoothOxoDishAv["visible"] <- TRUE
		BXSlopeOxoDishAv["visible"] <- TRUE
		BXConsOxoDishAv["visible"] <- as.logical(SETAnalysisOpt$slopeSelection["Data_oxoDishAv"])
		BXPlotGeneralSubOxoDishAv["visible"] <- TRUE
		FROutOxoDishAv["visible"] <- TRUE
		FROutOxoDishSd["visible"] <- as.logical(SETAnalysisOpt$SD)
		btnOxoDishAvShow["visible"] <- TRUE
		## Restrictions
		CKBSelectionOxoDish$setActive(is.active = TRUE)
	} else {
		## Settings
		SETAnalysisOpt$oxoDish[2] <- FALSE
		TEMPIC50Selection["Data_oxoDishAv"] <- FALSE
		## Layouts
		BXSmoothOxoDishAv["visible"] <- FALSE
		BXSlopeOxoDishAv["visible"] <- FALSE
		BXConsOxoDishAv["visible"] <- FALSE
		BXPlotGeneralSubOxoDishAv["visible"] <- FALSE
		FROutOxoDishAv["visible"] <- FALSE
		FROutOxoDishSd["visible"] <- FALSE
		btnOxoDishAvShow["visible"] <- FALSE
		## Restrictions
		CKBSmOxoDishAv$setActive(is.active = FALSE)
		CKBSlopeOxoDishAv$setActive(is.active = FALSE)
		CKBConsOxoDishAv$setActive(is.active = FALSE)
		ListOutputLayouts[["Data_oxoDishAv"]][["ckb"]]$setActive(is.active = FALSE)
		ListOutputLayouts[["Data_oxoDishSd"]][["ckb"]]$setActive(is.active = FALSE)
	}
	FRefreshIC50Selection()
	#print(SETAnalysisOpt$oxoDish)
}))

####
#### Signal: OxoDish calibration range
#####################################
ERROxoDishRange1 <- gtkLabel("-- Please enter a number > 1 for sensor correction range! --")
	ERROxoDishRange1["visible"] <- FALSE
	BXErrormessages$packStart(ERROxoDishRange1, expand = TRUE, fill = TRUE)
ERROxoDishRange2 <- gtkLabel("-- There are not as many timepoints for correction as you want to include! --")
	ERROxoDishRange2["visible"] <- FALSE
	BXErrormessages$packStart(ERROxoDishRange2, expand = TRUE, fill = TRUE)

gSignalConnect(ENTOxoDishCalNumber, "activate", quote({
	text <- as.numeric(ENTOxoDishCalNumber$getText())
	if (SETAnalysisOpt$oxoDish[1] == TRUE) {
		if (is.na(text) | text < 2) { #number smaller than 2 or text entered
			ERROxoDishRange1["visible"] <- TRUE
			ERROxoDishRange2["visible"] <- FALSE
		} else { #number greater than one entered
			SETAnalysisOpt$range[1] <- text
			ERROxoDishRange1["visible"] <- FALSE
			#if there is already a last value and the desired number is greater than the position of last show error
			if (SETAnalysisOpt$range[3] != 0 && text > SETAnalysisOpt$range[3]) ERROxoDishRange2["visible"] <- TRUE
			else ERROxoDishRange2["visible"] <- FALSE
		}
	}
	#print(SETAnalysisOpt$range)
}))

####
#### Signal: OxoDish calibration last
####################################
ERROxoDishLast1 <- gtkLabel("-- Please enter a positive number for last calibration value! --")
	ERROxoDishLast1["visible"] <- FALSE
	BXErrormessages$packStart(ERROxoDishLast1, expand = TRUE, fill = TRUE)
ERROxoDishLast2 <- gtkLabel("-- Given last value for sensor correction can't be found in imported data! --")
	ERROxoDishLast2["visible"] <- FALSE
	BXErrormessages$packStart(ERROxoDishLast2, expand = TRUE, fill = TRUE)
	
gSignalConnect(ENTOxoDishCalLast, "activate", quote({
	text <- as.numeric(ENTOxoDishCalLast$getText())
	if (SETAnalysisOpt$oxoDish[1] == TRUE) {
		if (is.na(text) == TRUE | text < 0) { #no number entered
			ERROxoDishLast1["visible"] <- TRUE
			ERROxoDishLast2["visible"] <- FALSE
			ERROxoDishRange1["visible"] <- FALSE
			ERROxoDishRange2["visible"] <- FALSE
		}  else if (Data_input[1,1] != "empty") {
			#Data is already imported and a number is entered -> check whether it can be found in data
			for (i in 1:length(Data_input$X)) {
				if (Data_input$X[i] == text) { #number can be found
					SETAnalysisOpt$range[2] <- text
					SETAnalysisOpt$range[3] <- i
					ERROxoDishLast1["visible"] <- FALSE
					ERROxoDishLast2["visible"] <- FALSE
					if (SETAnalysisOpt$range[1] > i) ERROxoDishRange2["visible"] <- TRUE
					else ERROxoDishRange2["visible"] <- FALSE
					break
				}
				ERROxoDishLast1["visible"] <- FALSE
				ERROxoDishLast2["visible"] <- TRUE
			}
		} else { #no data imported yet
			SETAnalysisOpt$range[2] <- text
			SETAnalysisOpt$range[3] <- 0
			ERROxoDishLast1["visible"] <- FALSE
			ERROxoDishLast2["visible"] <- FALSE
			ERROxoDishRange1["visible"] <- FALSE
			ERROxoDishRange2["visible"] <- FALSE
		}
	} else {
		ERROxoDishLast1["visible"] <- FALSE
		ERROxoDishLast2["visible"] <- FALSE
		ERROxoDishRange1["visible"] <- FALSE
		ERROxoDishRange2["visible"] <- FALSE
	}
	if (length(SETAnalysisOpt$Formatting) != 0) {
		if (checkFormatNumeric["t2"] == TRUE & checkFormatNumeric["t1"] == TRUE & SETAnalysisOpt$Formatting == "Data_raw") {
			timepoint <- SETAnalysisOpt$range["last"] * SETDataLayout$timescale / SETGraphOpt$XScale
			if (timepoint < SETAnalysisOpt$FormattingParam["t1"] | timepoint > SETAnalysisOpt$FormattingParam["t2"]) ERRFormatSensorConflict["visible"] <- TRUE
			else ERRFormatSensorConflict["visible"] <- FALSE
		} else ERRFormatSensorConflict["visible"] <- FALSE
	} else ERRFormatSensorConflict["visible"] <- FALSE
	#print(SETAnalysisOpt$range)
}))

####
#### Signal: OxoDish correction target
######################################
ERROxoDishTarget <- gtkLabel("-- Please enter a number for the sensor correction target! --")
	ERROxoDishTarget["visible"] <- FALSE
	BXErrormessages$packStart(ERROxoDishTarget, expand = TRUE, fill = TRUE)
	
gSignalConnect(ENTOxoDishCalTarget, "activate", quote({
	text <- as.numeric(ENTOxoDishCalTarget$getText())
	if (is.na(text) == TRUE & SETAnalysisOpt$oxoDish[1] == TRUE) {
		ERROxoDishTarget["visible"] <- TRUE
	} else {
		SETAnalysisOpt$oxoDishTarget <- text
		ERROxoDishTarget["visible"] <- FALSE
	}
}))

####
#### Signal: Span
#################
ERROxoDishSpan <- gtkLabel("-- Please enter a number for the span! --")
	ERROxoDishSpan["visible"] <- FALSE
	BXErrormessages$packStart(ERROxoDishSpan, expand = TRUE, fill = TRUE)

gSignalConnect(ENTOxoDishCalSpan, "activate", quote({
	text <- as.numeric(ENTOxoDishCalSpan$getText())
	if (is.na(text) == TRUE & SETAnalysisOpt$oxoDish[1] == TRUE) {
		ERROxoDishSpan["visible"] <- TRUE
	} else {
		SETAnalysisOpt$span <- text
		ERROxoDishSpan["visible"] <- FALSE
	}
}))

####
#### Signal: Plateau
####################
ERROxoDishPlateau <- gtkLabel("-- Please enter a number for the plateau! --")
	ERROxoDishPlateau["visible"] <- FALSE
	BXErrormessages$packStart(ERROxoDishPlateau, expand = TRUE, fill = TRUE)

gSignalConnect(ENTOxoDishCalPlateau, "activate", quote({
	text <- as.numeric(ENTOxoDishCalPlateau$getText())
	if (is.na(text) == TRUE & SETAnalysisOpt$oxoDish[1] == TRUE) {
		ERROxoDishPlateau["visible"] <- TRUE
	} else {
		SETAnalysisOpt$plateau <- text
		ERROxoDishPlateau["visible"] <- FALSE
	}
}))

####
#### Signal: Use sensor correction target value for saturation
##############################################################
gSignalConnect(btnConsSatOxoDish, "clicked", quote({
	if (SETAnalysisOpt$oxoDish[1] == TRUE & SETAnalysisOpt$ConsParam[1] == TRUE) {
		ENTConsSat$setText(SETAnalysisOpt$oxoDishTarget)
	}
}))

####
#### Signal: Selection OxoPlate cal
###################################
gSignalConnect(CKBSelectionOxoPlate, "toggled", quote({
	if (CKBSelectionOxoPlate$getActive() == TRUE) {
		## Settings
		SETAnalysisOpt$oxoPlate[1] <- TRUE
		TEMPIC50Selection["Data_oxoPlate"] <- TRUE
		TEMPFormatSelectData["Data_oxoPlate"] <- TRUE
		TEMPFormatSelectData["Data_raw"] <- FALSE
		SETAnalysisOpt$FormattingParams["y"] <- 1
		## Layouts
		BXFormatTransformY["visible"] <- FALSE
		FROxoPlateCal["visible"] <- TRUE
		BXSmoothOxoPlate["visible"] <- TRUE
		BXSlopeOxoPlate["visible"] <- TRUE
		BXConsOxoPlate["visible"] <- as.logical(SETAnalysisOpt$slopeSelection["Data_oxoPlate"])
		BXPlotGeneralSubOxoPlate["visible"] <- TRUE
		FROutOxoPlate["visible"] <- TRUE
		FRMiniaturOxoPlate["visible"] <- TRUE
		## Restrictions - none
	} else {
		## Settings
		SETAnalysisOpt$oxoPlate[1] <- FALSE
		TEMPIC50Selection[["Data_oxoPlate"]] <- FALSE
		TEMPFormatSelectData[["Data_oxoPlate"]] <- FALSE
		if (SETAnalysisOpt$hydroPlate[1] == FALSE) {
			TEMPFormatSelectData["Data_raw"] <- TRUE
			BXFormatTransformY["visible"] <- TRUE
		}
		## Layouts
		FROxoPlateCal["visible"] <- FALSE
		BXSmoothOxoPlate["visible"] <- FALSE
		BXSlopeOxoPlate["visible"] <- FALSE
		BXConsOxoPlate["visible"] <- FALSE
		BXPlotGeneralSubOxoPlate["visible"] <- FALSE
		FROutOxoPlate["visible"] <- FALSE
		FRMiniaturOxoPlate["visible"] <- FALSE
		## Restrictions
		CKBSelectionOxoPlateAv$setActive(is.active = FALSE)
		CKBSmOxoPlate$setActive(is.active = FALSE)
		CKBSlopeOxoPlate$setActive(is.active = FALSE)
		CKBConsOxoPlate$setActive(is.active = FALSE)
		ListOutputLayouts[["Data_oxoPlate"]][[3]]$setActive(is.active = FALSE)
	}
	FRefreshIC50Selection()
	FRefreshFormattingSelection()
	#print(SETAnalysisOpt$oxoPlate)
}))

####
#### Signal: Selection OxoPlate cal average
###########################################
gSignalConnect(CKBSelectionOxoPlateAv, "toggled", quote({
	if (CKBSelectionOxoPlateAv$getActive() == TRUE) {
		## Settings
		SETAnalysisOpt$oxoPlate[2] <- TRUE
		TEMPIC50Selection["Data_oxoPlateAv"] <- TRUE
		## Layouts
		BXSmoothOxoPlateAv["visible"] <- TRUE
		BXSlopeOxoPlateAv["visible"] <- TRUE
		BXConsOxoPlateAv["visible"] <- as.logical(SETAnalysisOpt$slopeSelection["Data_oxoPlateAv"])
		BXPlotGeneralSubOxoPlateAv["visible"] <- TRUE
		FROutOxoPlateAv["visible"] <- TRUE
		FROutOxoPlateSd["visible"] <- as.logical(SETAnalysisOpt$SD)
		btnOxoPlateAvShow["visible"] <- TRUE
		## Restrictions
		CKBSelectionOxoPlate$setActive(is.active = TRUE)
	} else {
		## Settings
		SETAnalysisOpt$oxoPlate[2] <- FALSE
		TEMPIC50Selection[["Data_oxoPlateAv"]] <- FALSE
		## Layouts
		BXSmoothOxoPlateAv["visible"] <- FALSE
		BXSlopeOxoPlateAv["visible"] <- FALSE
		BXConsOxoPlateAv["visible"] <- FALSE
		BXPlotGeneralSubOxoPlateAv["visible"] <- FALSE
		FROutOxoPlateAv["visible"] <- FALSE
		FROutOxoPlateSd["visible"] <- FALSE
		btnOxoPlateAvShow["visible"] <- FALSE
		## Restrictions
		CKBSmOxoPlateAv$setActive(is.active = FALSE)
		CKBSlopeOxoPlateAv$setActive(is.active = FALSE)
		CKBConsOxoPlateAv$setActive(is.active = FALSE)
		ListOutputLayouts[["Data_oxoPlateAv"]][[3]]$setActive(is.active = FALSE)
		ListOutputLayouts[["Data_oxoPlateSd"]][[3]]$setActive(is.active = FALSE)
	}
	FRefreshIC50Selection()
	#print(SETAnalysisOpt$oxoPlate)
}))

####
#### Signal: 0 % ox name
########################
ERR0OxName <- gtkLabel("-- Given name for 0 % oxygen wells is not in the label list! --")
	ERR0OxName["visible"] <- FALSE
	BXErrormessages$packStart(ERR0OxName, expand = TRUE, fill = TRUE)

gSignalConnect(ENTOxoPlateCal0, "activate", quote({
	text <- ENTOxoPlateCal0$getText()
	if (Template[1,1] != "empty" & SETAnalysisOpt$oxoPlate[1] == TRUE) {
		for (i in 1:length(Template$X)) {
			if (Template$Name[i] == text) {
				SETAnalysisOpt$cal0100[1] <- text
				ERR0OxName["visible"] <- FALSE
				break
			}
			ERR0OxName["visible"] <- TRUE
		}
	} else { #no template loaded yet
		SETAnalysisOpt$cal0100[1] <- text
		ERR0OxName["visible"] <- FALSE
	}
}))

####
#### Signal: 100 % ox name
########################
ERR100OxName <- gtkLabel("-- Given name for 100 % oxygen wells is not in the label list! --")
	ERR100OxName["visible"] <- FALSE
	BXErrormessages$packStart(ERR100OxName, expand = TRUE, fill = TRUE)

gSignalConnect(ENTOxoPlateCal100, "activate", quote({
	text <- ENTOxoPlateCal100$getText()
	if (Template[1,1] != "empty" & SETAnalysisOpt$oxoPlate[1] == TRUE) {
		for (i in 1:length(Template$X)) {
			if (Template$Name[i] == text) {
				SETAnalysisOpt$cal0100[2] <- text
				ERR100OxName["visible"] <- FALSE
				break
			}
			ERR100OxName["visible"] <- TRUE
		}
	} else { #no template loaded yet
		SETAnalysisOpt$cal0100[2] <- text
		ERR100OxName["visible"] <- FALSE
	}
}))

####
#### Signal: Unit selection
##########################
gSignalConnect(COMOxoPlateCalTargetUnit, "changed", quote({
	SETAnalysisOpt$unitselections[1] <- COMOxoPlateCalTargetUnit$getActive()
	if (COMOxoPlateCalTTemp$getActiveText() != "other" & COMOxoPlateCalTPres$getActiveText() != "other" & COMOxoPlateCalTargetUnit$getActiveText() != "other") {
		ENTOxoPlateCalTfactor$setText(FactorLists[[(SETAnalysisOpt$unitselections[1]+1)]][(SETAnalysisOpt$unitselections[2]+1),(SETAnalysisOpt$unitselections[3]+1)])
		ENTOxoPlateCalTfactor["editable"] <- FALSE
	} else {
		ENTOxoPlateCalTfactor["editable"] <- TRUE
	}
}))

####
#### Signal: Pressure
#####################
gSignalConnect(COMOxoPlateCalTPres, "changed", quote({
	SETAnalysisOpt$unitselections[3] <- COMOxoPlateCalTPres$getActive()
	if (COMOxoPlateCalTTemp$getActiveText() != "other" & COMOxoPlateCalTPres$getActiveText() != "other" & COMOxoPlateCalTargetUnit$getActiveText() != "other") {
		ENTOxoPlateCalTfactor$setText(FactorLists[[COMOxoPlateCalTargetUnit$getActiveText()]][COMOxoPlateCalTTemp$getActiveText(), 1])
		ENTOxoPlateCalTfactor["editable"] <- FALSE
	} else {
		ENTOxoPlateCalTfactor["editable"] <- TRUE
	}
}))

####
#### Signal: Temperature
########################
gSignalConnect(COMOxoPlateCalTTemp, "changed", quote({
	SETAnalysisOpt$unitselections[2] <- COMOxoPlateCalTTemp$getActive()
	if (COMOxoPlateCalTTemp$getActiveText() != "other" & COMOxoPlateCalTPres$getActiveText() != "other" & COMOxoPlateCalTargetUnit$getActiveText() != "other") {
		ENTOxoPlateCalTfactor$setText(FactorLists[[(SETAnalysisOpt$unitselections[1]+1)]][(SETAnalysisOpt$unitselections[2]+1),(SETAnalysisOpt$unitselections[3]+1)])
		ENTOxoPlateCalTfactor["editable"] <- FALSE
	} else {
		ENTOxoPlateCalTfactor["editable"] <- TRUE
	}
}))

####
#### Signal: Factor
###################
ERRFactor <- gtkLabel("-- Please enter a number for the unit conversion factor! --")
	ERRFactor["visible"] <- FALSE
	BXErrormessages$packStart(ERRFactor, expand = TRUE, fill = TRUE)

gSignalConnect(ENTOxoPlateCalTfactor, "activate", quote({
	text <- as.numeric(ENTOxoPlateCalTfactor$getText())
	if (is.na(text) == TRUE & SETAnalysisOpt$oxoPlate[1] == TRUE) {
		ERRFactor["visible"] <- TRUE
	} else {
		SETAnalysisOpt$factor <- text
		ERRFactor["visible"] <- FALSE
	}
}))

####
#### Signal: Selection HydroPlate cal
#####################################
gSignalConnect(CKBSelectionHydroPlate, "toggled", quote({
	if (CKBSelectionHydroPlate$getActive() == TRUE) {
		## Settings
		SETAnalysisOpt$hydroPlate[1] <- TRUE
		TEMPIC50Selection["Data_hydroPlate"] <- TRUE
		TEMPFormatSelectData["Data_hydroPlate"] <- TRUE
		TEMPFormatSelectData["Data_raw"] <- FALSE
		SETAnalysisOpt$FormattingParams["y"] <- 1
		## Layouts
		BXFormatTransformY["visible"] <- FALSE
		FRHydroPlateCal["visible"] <- TRUE
		BXSmoothHydroPlate["visible"] <- TRUE
		BXSlopeHydroPlate["visible"] <- TRUE
		BXPlotGeneralSubHydroPlate["visible"] <- TRUE
		BXPlotGeneralSubHydroPlateCal["visible"] <- TRUE
		FROutHydroPlate["visible"] <- TRUE
		FROutHydroPlateCal["visible"] <- TRUE
		FRMiniaturHydroPlate["visible"] <- TRUE
		## Restrictions - none
	} else {
		## Settings
		SETAnalysisOpt$hydroPlate[1] <- FALSE
		TEMPIC50Selection[["Data_hydroPlate"]] <- FALSE
		TEMPFormatSelectData[["Data_hydroPlate"]] <- FALSE
		if (SETAnalysisOpt$oxoPlate[1] == FALSE) {
			TEMPFormatSelectData["Data_raw"] <- TRUE
			BXFormatTransformY["visible"] <- TRUE
		}
		## Layouts
		FRHydroPlateCal["visible"] <- FALSE
		BXSmoothHydroPlate["visible"] <- FALSE
		BXSlopeHydroPlate["visible"] <- FALSE
		BXPlotGeneralSubHydroPlate["visible"] <- FALSE
		BXPlotGeneralSubHydroPlateCal["visible"] <- FALSE
		FROutHydroPlate["visible"] <- FALSE
		FROutHydroPlateCal["visible"] <- FALSE
		FRMiniaturHydroPlate["visible"] <- FALSE
		## Restrictions
		CKBSelectionHydroPlateAv$setActive(is.active = FALSE)
		CKBSmHydroPlate$setActive(is.active = FALSE)
		CKBSlopeHydroPlate$setActive(is.active = FALSE)
		ListOutputLayouts[["Data_hydroPlate"]][[3]]$setActive(is.active = FALSE)
		ListOutputLayouts[["Data_hydroPlateCal"]][[3]]$setActive(is.active = FALSE)
	}
	FRefreshIC50Selection()
	FRefreshFormattingSelection()
	#print(SETAnalysisOpt$hydroPlate)
}))

####
#### Signal: Selection HydroPlate cal average
#############################################
gSignalConnect(CKBSelectionHydroPlateAv, "toggled", quote({
	if (CKBSelectionHydroPlateAv$getActive() == TRUE) {
		## Settings
		SETAnalysisOpt$hydroPlate[2] <- TRUE
		TEMPIC50Selection["Data_hydroPlateAv"] <- TRUE
		## Layouts
		BXSmoothHydroPlateAv["visible"] <- TRUE
		BXSlopeHydroPlateAv["visible"] <- TRUE
		BXPlotGeneralSubHydroPlateAv["visible"] <- TRUE
		FROutHydroPlateAv["visible"] <- TRUE
		FROutHydroPlateSd["visible"] <- as.logical(SETAnalysisOpt$SD)
		btnHydroPlateAvShow["visible"] <- TRUE
		## Restrictions
		CKBSelectionHydroPlate$setActive(is.active = TRUE)
	} else {
		## Settings
		SETAnalysisOpt$hydroPlate[2] <- FALSE
		TEMPIC50Selection[["Data_hydroPlateAv"]] <- FALSE
		## Layouts
		BXSmoothHydroPlateAv["visible"] <- FALSE
		BXSlopeHydroPlateAv["visible"] <- FALSE
		BXPlotGeneralSubHydroPlateAv["visible"] <- FALSE
		FROutHydroPlateAv["visible"] <- FALSE
		FROutHydroPlateSd["visible"] <- FALSE
		btnHydroPlateAvShow["visible"] <- FALSE
		## Restrictions
		CKBSmHydroPlateAv$setActive(is.active = FALSE)
		CKBSlopeHydroPlateAv$setActive(is.active = FALSE)
		ListOutputLayouts[["Data_hydroPlateAv"]][[3]]$setActive(is.active = FALSE)
		ListOutputLayouts[["Data_hydroPlateSd"]][[3]]$setActive(is.active = FALSE)
	}
	FRefreshIC50Selection()
	#print(SETAnalysisOpt$hydroPlate)
}))

####
#### Function: Check pH values
##############################
ERRpH <- gtkLabel("-- Please enter numerical values > 0 or -1 only for the pH values! --")
ERRpH["visible"] <- FALSE
	BXErrormessages$packStart(ERRpH, expand = FALSE, fill = FALSE)

FCheckHydropHs <- function(T) {
	names <- levels(as.factor(T$Name))
	pHs <- c()
	rem <- c()
	proceed <- 1
	if (length(TEMPpHs) != 0 && length(names) != 0) {
		for(i in 1:length(names)) {
			if (class(TEMPpHs[[names[i]]]$entry)[1] == "GtkEntry") {
				pH <- tryCatch(as.numeric(gtkEntryGetText(TEMPpHs[[names[i]]]$entry)), warning = function(W) {return(-2)})
				if (pH == -1 | pH >= 0) {
					pHs <- c(pHs, as.numeric(pH))
					ERRpH["visible"] <- FALSE
				} else {
					ERRpH["visible"] <- TRUE
					proceed <- 0
					break
				}
			}
			else rem <- c(rem, i)
		}
	}
	if (proceed == 1 & length(rem) != 0) SETAnalysisOpt$hydroPlateCal <<- data.frame(Name = names[-rem], pH = pHs)
	else if (proceed == 1 & length(rem) == 0) SETAnalysisOpt$hydroPlateCal <<- data.frame(Name = names, pH = pHs)
}

#############################
#### Analysis Options execute
#############################
CheckInputAnalysisOpt <- c(CheckInputAnalysisOpt, CKBSelectionOxoDish, CKBSelectionOxoDishAv, ENTOxoDishCalNumber, ENTOxoDishCalLast, ENTOxoDishCalTarget, ENTOxoDishCalSpan, ENTOxoDishCalPlateau, CKBSelectionOxoPlate, CKBSelectionOxoPlateAv, ENTOxoPlateCal0, ENTOxoPlateCal100, COMOxoPlateCalTargetUnit, COMOxoPlateCalTPres, COMOxoPlateCalTTemp, ENTOxoPlateCalTfactor, CKBSelectionHydroPlate, CKBSelectionHydroPlateAv)

####
#### Function: Activate all Input for Analysis Options
######################################################
FCheckAnalysisOpt <- function(Input) {
	for (i in 1:length(Input)) {
		if (class(Input[[i]])[1] == "GtkRadioButton") {
			gSignalEmit(Input[[i]], "toggled")
		} else if (class(Input[[i]])[1] == "GtkEntry") {
			gSignalEmit(Input[[i]], "activate")
		} else if (class(Input[[i]])[1] == "GtkCheckButton") {
			gSignalEmit(Input[[i]], "toggled")
		} else if (class(Input[[i]])[1] == "GtkComboBox") {
			gSignalEmit(Input[[i]], "changed")
		}
	}
	
	## Check Doses for IC50 and pH values
	FCheckIC50Doses(Template)
	FCheckHydropHs(Template)
}

#########################################################################################
#### Graph output
#########################################################################################

####
#### Miniatur Frame
###################
FRMiniaturOxoDish <- gtkFrame("Sensor corrected data")
FRMiniaturOxoDish$setBorderWidth(2)
FRMiniaturOxoPlate <- gtkFrame("Converted OxoPlate data")
FRMiniaturOxoPlate$setBorderWidth(2)
FRMiniaturHydroPlate <- gtkFrame("Converted HydroPlate data")
FRMiniaturHydroPlate$setBorderWidth(2)
	BXMiniatur$packStart(FRMiniaturOxoDish, expand = TRUE, fill = TRUE)
	BXMiniatur$packStart(FRMiniaturOxoPlate, expand = TRUE, fill = TRUE)
	BXMiniatur$packStart(FRMiniaturHydroPlate, expand = TRUE, fill = TRUE)
	BXMiniatur$packStart(FRMiniaturMedium, expand = TRUE, fill = TRUE)
	BXMiniatur$packStart(FRMiniaturIC50, expand = TRUE, fill = TRUE)
BXMiniaturOxoDish <- gtkVBox(FALSE, 5)
	FRMiniaturOxoDish$add(BXMiniaturOxoDish)
BXMiniaturOxoPlate <- gtkVBox(FALSE, 5)
	FRMiniaturOxoPlate$add(BXMiniaturOxoPlate)
BXMiniaturHydroPlate <- gtkVBox(FALSE, 5)
	FRMiniaturHydroPlate$add(BXMiniaturHydroPlate)

## Buttons
btnOxoDishShow <- gtkButton("Sensor corrected data")
btnOxoDishOrigShow <- gtkButton("- Before formatting")
btnOxoDishSmShow <- gtkButton("- Smoothed")
btnOxoDishSlopeShow <- gtkButton("- Slope")
btnOxoDishConsShow <- gtkButton("- Consumption")
btnOxoDishAvShow <- gtkButton("- Average")
btnOxoDishAvSmShow <- gtkButton("- Smoothed average")
btnOxoDishAvSlopeShow <- gtkButton("- Average slope")
btnOxoDishAvConsShow <- gtkButton("- Average consumption")
	BXMiniaturOxoDish$packStart(btnOxoDishShow, expand = TRUE, fill = TRUE)
	BXMiniaturOxoDish$packStart(btnOxoDishOrigShow, expand = TRUE, fill = TRUE)
	BXMiniaturOxoDish$packStart(btnOxoDishSmShow, expand = TRUE, fill = TRUE)
	BXMiniaturOxoDish$packStart(btnOxoDishSlopeShow, expand = TRUE, fill = TRUE)
	BXMiniaturOxoDish$packStart(btnOxoDishConsShow, expand = TRUE, fill = TRUE)
	BXMiniaturOxoDish$packStart(btnOxoDishAvShow, expand = TRUE, fill = TRUE)
	BXMiniaturOxoDish$packStart(btnOxoDishAvSmShow, expand = TRUE, fill = TRUE)
	BXMiniaturOxoDish$packStart(btnOxoDishAvSlopeShow, expand = TRUE, fill = TRUE)
	BXMiniaturOxoDish$packStart(btnOxoDishAvConsShow, expand = TRUE, fill = TRUE)
btnOxoPlateShow <- gtkButton("OxoPlate data")
btnOxoPlateOrigShow <- gtkButton("- Before formatting")
btnOxoPlateSmShow <- gtkButton("- Smoothed")
btnOxoPlateSlopeShow <- gtkButton("- Slope")
btnOxoPlateConsShow <- gtkButton("- Consumption")
btnOxoPlateAvShow <- gtkButton("- Average")
btnOxoPlateAvSmShow <- gtkButton("- Smoothed average")
btnOxoPlateAvSlopeShow <- gtkButton("- Average slope")
btnOxoPlateAvConsShow <- gtkButton("- Average consumption")
	BXMiniaturOxoPlate$packStart(btnOxoPlateShow, expand = TRUE, fill = TRUE)
	BXMiniaturOxoPlate$packStart(btnOxoPlateOrigShow, expand = TRUE, fill = TRUE)
	BXMiniaturOxoPlate$packStart(btnOxoPlateSmShow, expand = TRUE, fill = TRUE)
	BXMiniaturOxoPlate$packStart(btnOxoPlateSlopeShow, expand = TRUE, fill = TRUE)
	BXMiniaturOxoPlate$packStart(btnOxoPlateConsShow, expand = TRUE, fill = TRUE)
	BXMiniaturOxoPlate$packStart(btnOxoPlateAvShow, expand = TRUE, fill = TRUE)
	BXMiniaturOxoPlate$packStart(btnOxoPlateAvSmShow, expand = TRUE, fill = TRUE)
	BXMiniaturOxoPlate$packStart(btnOxoPlateAvSlopeShow, expand = TRUE, fill = TRUE)
	BXMiniaturOxoPlate$packStart(btnOxoPlateAvConsShow, expand = TRUE, fill = TRUE)
btnHydroPlateShow <- gtkButton("HydroPlate data")
btnHydroPlateOrigShow <- gtkButton("- Before formatting")
btnHydroPlateCalShow <- gtkButton("- Calibration values")
btnHydroPlateSmShow <- gtkButton("- Smoothed")
btnHydroPlateSlopeShow <- gtkButton("- Slope")
btnHydroPlateAvShow <- gtkButton("- Average")
btnHydroPlateAvSmShow <- gtkButton("- Smoothed average")
btnHydroPlateAvSlopeShow <- gtkButton("- Average slope")
	BXMiniaturHydroPlate$packStart(btnHydroPlateShow, expand = TRUE, fill = TRUE)
	BXMiniaturHydroPlate$packStart(btnHydroPlateOrigShow, expand = TRUE, fill = TRUE)
	BXMiniaturHydroPlate$packStart(btnHydroPlateCalShow, expand = TRUE, fill = TRUE)
	BXMiniaturHydroPlate$packStart(btnHydroPlateSmShow, expand = TRUE, fill = TRUE)
	BXMiniaturHydroPlate$packStart(btnHydroPlateSlopeShow, expand = TRUE, fill = TRUE)
	BXMiniaturHydroPlate$packStart(btnHydroPlateAvShow, expand = TRUE, fill = TRUE)
	BXMiniaturHydroPlate$packStart(btnHydroPlateAvSmShow, expand = TRUE, fill = TRUE)
	BXMiniaturHydroPlate$packStart(btnHydroPlateAvSlopeShow, expand = TRUE, fill = TRUE)
	
#########################################################################################
#### Graph output Interactive
#########################################################################################

####
#### Signal: OxoDish Miniatur clicked
#####################################
gSignalConnect(btnOxoDishShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Sensor corrected data")
	CKBShowSd["visible"] <- FALSE
	CKBShowSd$setActive(is.active = FALSE)
	BXCurrentGraphIC50["visible"] <- FALSE
	if (class(Data_oxoDish[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_oxoDish)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoDish, T = Template, subnumber = "oxoDish")
		if (TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Unformatted OxoDish Miniatur clicked
#################################################
gSignalConnect(btnOxoDishOrigShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Unformatted sensor corrected data")
	CKBShowSd["visible"] <- FALSE
	CKBShowSd$setActive(is.active = FALSE)
	BXCurrentGraphIC50["visible"] <- FALSE
	if (class(Data_oxoDishOrig[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_oxoDishOrig)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoDishOrig, T = Template, subnumber = "oxoDishOrig")
		if (TEMPChecksums$Data_oxoDishOrig[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Smoothed OxoDish Miniatur clicked
##############################################
gSignalConnect(btnOxoDishSmShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Sensor corrected data smoothed")
	CKBShowSd["visible"] <- FALSE
	CKBShowSd$setActive(is.active = FALSE)
	BXCurrentGraphIC50["visible"] <- FALSE
	if (class(Data_oxoDishSm[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_oxoDishSm)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoDishSm, T = Template, subnumber = "oxoDishSm")
		if (TEMPChecksums$Data_oxoDishSm[1] != TEMPChecksums$Data_oxoDish[2] | TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Slope of OxoDish Miniatur clicked
##############################################
gSignalConnect(btnOxoDishSlopeShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Sensor corrected data slope")
	CKBShowSd["visible"] <- TRUE
	if (class(Data_oxoDishSlope[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_oxoDishSlope)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoDishSlope, DSd = Data_oxoDishSlopeSd, T = Template, subnumber = "oxoDishSlope")
		if (TEMPChecksums$Data_oxoDishSlope[1] != TEMPChecksums$Data_oxoDish[2] | TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Consumption of OxoDish Miniatur clicked
####################################################
gSignalConnect(btnOxoDishConsShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Sensor corrected data consumption")
	CKBShowSd["visible"] <- TRUE
	if (class(Data_oxoDishCons[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_oxoDishCons)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoDishCons, DSd = Data_oxoDishConsSd, T = Template, subnumber = "oxoDishCons", altYLabel = SETAnalysisOpt$ConsCharacters["axis"])
		if (TEMPChecksums$Data_oxoDishCons[1] != TEMPChecksums$Data_oxoDishSlope[2]| TEMPChecksums$Data_oxoDishSlope[1] != TEMPChecksums$Data_oxoDish[2] | TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: OxoDish Average Miniatur clicked
#############################################
gSignalConnect(btnOxoDishAvShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Average sensor corrected data")
	if (SETAnalysisOpt$oxoDish[2] == TRUE & SETAnalysisOpt$SD == TRUE) CKBShowSd["visible"] <- TRUE
	else {
		CKBShowSd["visible"] <- FALSE
		CKBShowSd$setActive(is.active = FALSE)
	}
	BXCurrentGraphIC50["visible"] <- FALSE
	if (class(Data_oxoDishAv[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FTemplateMean()
		FCheckboxConstruct(Data_oxoDishAv)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoDishAv, DSd = Data_oxoDishSd, T = TemplateAverage, subnumber = "oxoDishAv")
		if (TEMPChecksums$Data_oxoDishAv[1] != TEMPChecksums$Data_oxoDish[2] | TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Smoothed OxoDish Average Miniatur clicked
######################################################
gSignalConnect(btnOxoDishAvSmShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Average sensor corrected data smoothed")
	CKBShowSd["visible"] <- FALSE
	CKBShowSd$setActive(is.active = FALSE)
	BXCurrentGraphIC50["visible"] <- FALSE
	if (class(Data_oxoDishAvSm[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FTemplateMean()
		FCheckboxConstruct(Data_oxoDishAvSm)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoDishAvSm, T = TemplateAverage, subnumber = "oxoDishAvSm")
		if (TEMPChecksums$Data_oxoDishAvSm[1] != TEMPChecksums$Data_oxoDishAv[2] | TEMPChecksums$Data_oxoDishAv[1] != TEMPChecksums$Data_oxoDish[2] | TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Slope of average OxoDish Miniatur clicked
######################################################
gSignalConnect(btnOxoDishAvSlopeShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Average sensor corrected data slope")
	CKBShowSd["visible"] <- TRUE
	if (class(Data_oxoDishAvSlope[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_oxoDishAvSlope)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoDishAvSlope, DSd = Data_oxoDishAvSlopeSd, T = TemplateAverage, subnumber = "oxoDishAvSlope")
		if (TEMPChecksums$Data_oxoDishAvSlope[1] != TEMPChecksums$Data_oxoDishAv[2] | TEMPChecksums$Data_oxoDishAv[1] != TEMPChecksums$Data_oxoDish[2] | TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Consumption of average OxoDish Miniatur clicked
############################################################
gSignalConnect(btnOxoDishAvConsShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Average sensor corrected data consumption")
	CKBShowSd["visible"] <- TRUE
	if (class(Data_oxoDishAvCons[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_oxoDishAvCons)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoDishAvCons, DSd = Data_oxoDishAvConsSd, T = TemplateAverage, subnumber = "oxoDishAvCons", altYLabel = SETAnalysisOpt$ConsCharacters["axis"])
		if (TEMPChecksums$Data_oxoDishAvCons[1] != TEMPChecksums$Data_oxoDishAvSlope[2] | TEMPChecksums$Data_oxoDishAvSlope[1] != TEMPChecksums$Data_oxoDishAv[2] | TEMPChecksums$Data_oxoDishAv[1] != TEMPChecksums$Data_oxoDish[2] | TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: OxoPlate Miniatur clicked
######################################
gSignalConnect(btnOxoPlateShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Converted OxoPlate data")
	CKBShowSd["visible"] <- FALSE
	CKBShowSd$setActive(is.active = FALSE)
	BXCurrentGraphIC50["visible"] <- FALSE
	if (class(Data_oxoPlate[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_oxoPlate)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoPlate, T = Template, subnumber = "oxoPlate")
		if (TEMPChecksums$Data_oxoPlate[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Unformatted OxoPlate Miniatur clicked
##################################################
gSignalConnect(btnOxoPlateOrigShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Unformatted OxoPlate data")
	CKBShowSd["visible"] <- FALSE
	CKBShowSd$setActive(is.active = FALSE)
	BXCurrentGraphIC50["visible"] <- FALSE
	if (class(Data_oxoPlateOrig[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_oxoPlateOrig)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoPlateOrig, T = Template, subnumber = "oxoPlateOrig")
		if (TEMPChecksums$Data_oxoPlateOrig[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Smoothed OxoPlate Miniatur clicked
###############################################
gSignalConnect(btnOxoPlateSmShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("OxoPlate data smoothed")
	CKBShowSd["visible"] <- FALSE
	CKBShowSd$setActive(is.active = FALSE)
	BXCurrentGraphIC50["visible"] <- FALSE
	if (class(Data_oxoPlateSm[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_oxoPlateSm)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoPlateSm, T = Template, subnumber = "oxoPlateSm")
		if (TEMPChecksums$Data_oxoPlateSm[1] != TEMPChecksums$Data_oxoPlate[2] | TEMPChecksums$Data_oxoPlate[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Slope of OxoPlate Miniatur clicked
###############################################
gSignalConnect(btnOxoPlateSlopeShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("OxoPlate data slope")
	CKBShowSd["visible"] <- TRUE
	if (class(Data_oxoPlateSlope[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_oxoPlateSlope)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoPlateSlope, DSd = Data_oxoPlateSlopeSd, T = Template, subnumber = "oxoPlateSlope")
		if (TEMPChecksums$Data_oxoPlateSlope[1] != TEMPChecksums$Data_oxoPlate[2] | TEMPChecksums$Data_oxoPlate[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Consumption of OxoPlate Miniatur clicked
#####################################################
gSignalConnect(btnOxoPlateConsShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("OxoPlate data consumption")
	CKBShowSd["visible"] <- TRUE
	if (class(Data_oxoPlateCons[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_oxoPlateCons)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoPlateCons, DSd = Data_oxoPlateConsSd, T = Template, subnumber = "oxoPlateCons", altYLabel = SETAnalysisOpt$ConsCharacters["axis"])
		if (TEMPChecksums$Data_oxoPlateCons[1] != TEMPChecksums$Data_oxoPlateSlope[2] | TEMPChecksums$Data_oxoPlateSlope[1] != TEMPChecksums$Data_oxoPlate[2] | TEMPChecksums$Data_oxoPlate[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: OxoPlate Average Miniatur clicked
##############################################
gSignalConnect(btnOxoPlateAvShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Average OxoPlate data")
	if (SETAnalysisOpt$oxoPlate[2] == TRUE & SETAnalysisOpt$SD == TRUE) CKBShowSd["visible"] <- TRUE
	else {
		CKBShowSd["visible"] <- FALSE
		CKBShowSd$setActive(is.active = FALSE)
	}
	BXCurrentGraphIC50["visible"] <- FALSE
	if (class(Data_oxoPlateAv[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FTemplateMean()
		FCheckboxConstruct(Data_oxoPlateAv)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoPlateAv, DSd = Data_oxoPlateSd, T = TemplateAverage, subnumber = "oxoPlateAv")
		if (TEMPChecksums$Data_oxoPlateAv[1] != TEMPChecksums$Data_oxoPlate[2] | TEMPChecksums$Data_oxoPlate[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Smoothed OxoPlate Average Miniatur clicked
#######################################################
gSignalConnect(btnOxoPlateAvSmShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Average OxoPlate data smoothed")
	CKBShowSd["visible"] <- FALSE
	CKBShowSd$setActive(is.active = FALSE)
	BXCurrentGraphIC50["visible"] <- FALSE
	if (class(Data_oxoPlateAvSm[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FTemplateMean()
		FCheckboxConstruct(Data_oxoPlateAvSm)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoPlateAvSm, T = TemplateAverage, subnumber = "oxoPlateAvSm")
		if (TEMPChecksums$Data_oxoPlateAvSm[1] != TEMPChecksums$Data_oxoPlateAv[2] | TEMPChecksums$Data_oxoPlateAv[1] != TEMPChecksums$Data_oxoPlate[2] | TEMPChecksums$Data_oxoPlate[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Slope of average OxoPlate Miniatur clicked
#######################################################
gSignalConnect(btnOxoPlateAvSlopeShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Average OxoPlate data slope")
	CKBShowSd["visible"] <- TRUE
	if (class(Data_oxoPlateAvSlope[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_oxoPlateAvSlope)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoPlateAvSlope, DSd = Data_oxoPlateAvSlopeSd, T = TemplateAverage, subnumber = "oxoPlateAvSlope")
		if (TEMPChecksums$Data_oxoPlateAvSlope[1] != TEMPChecksums$Data_oxoPlateAv[2] | TEMPChecksums$Data_oxoPlateAv[1] != TEMPChecksums$Data_oxoPlate[2] | TEMPChecksums$Data_oxoPlate[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Consumption of average OxoPlate Miniatur clicked
#############################################################
gSignalConnect(btnOxoPlateAvConsShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Average OxoPlate data consumption")
	CKBShowSd["visible"] <- TRUE
	if (class(Data_oxoPlateAvCons[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_oxoPlateAvCons)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_oxoPlateAvCons, DSd = Data_oxoPlateAvConsSd, T = TemplateAverage, subnumber = "oxoPlateAvCons", altYLabel = SETAnalysisOpt$ConsCharacters["axis"])
		if (TEMPChecksums$Data_oxoPlateAvCons[1] != TEMPChecksums$Data_oxoPlateAvSlope[2] | TEMPChecksums$Data_oxoPlateAvSlope[1] != TEMPChecksums$Data_oxoPlateAv[2] | TEMPChecksums$Data_oxoPlateAv[1] != TEMPChecksums$Data_oxoPlate[2] | TEMPChecksums$Data_oxoPlate[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: HydroPlate Miniatur clicked
########################################
gSignalConnect(btnHydroPlateShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Converted HydroPlate data")
	CKBShowSd["visible"] <- FALSE
	CKBShowSd$setActive(is.active = FALSE)
	BXCurrentGraphIC50["visible"] <- FALSE
	if (class(Data_hydroPlate[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_hydroPlate)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_hydroPlate, T = Template, subnumber = "hydroPlate")
		if (TEMPChecksums$Data_hydroPlate[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Formatted HydroPlate Miniatur clicked
##################################################
gSignalConnect(btnHydroPlateOrigShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Unformatted converted HydroPlate data")
	CKBShowSd["visible"] <- FALSE
	CKBShowSd$setActive(is.active = FALSE)
	BXCurrentGraphIC50["visible"] <- FALSE
	if (class(Data_hydroPlateOrig[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_hydroPlateOrig)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_hydroPlateOrig, T = Template, subnumber = "hydroPlateOrig")
		if (TEMPChecksums$Data_hydroPlateOrig[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: HydroPlate Calibration Miniatur clicked
####################################################
gSignalConnect(btnHydroPlateCalShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Calibration values for HydroPlate data")
	CKBShowSd["visible"] <- FALSE
	CKBShowSd$setActive(is.active = FALSE)
	BXCurrentGraphIC50["visible"] <- FALSE
	if (class(Data_hydroPlateCal[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_hydroPlateCal)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_hydroPlateCal, T = data.frame(X = c("Imin", "Imax", "pH0", "dpH"), Name = c("Imin", "Imax", "pH0", "dpH"), Number = c(1,2,3,4), Colour = c("darkgrey", "black", "green", "red"), Linetype = c("solid", "solid", "solid", "solid")), subnumber = "hydroPlateCal")
		if (TEMPChecksums$Data_hydroPlateCal[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Smoothed HydroPlate Miniatur clicked
#################################################
gSignalConnect(btnHydroPlateSmShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("HydroPlate data smoothed")
	CKBShowSd["visible"] <- FALSE
	CKBShowSd$setActive(is.active = FALSE)
	BXCurrentGraphIC50["visible"] <- FALSE
	if (class(Data_hydroPlateSm[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_hydroPlateSm)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_hydroPlateSm, T = Template, subnumber = "hydroPlateSm")
		if (TEMPChecksums$Data_hydroPlateSm[1] != TEMPChecksums$Data_hydroPlate[2] | TEMPChecksums$Data_hydroPlate[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Slope of HydroPlate Miniatur clicked
###############################################
gSignalConnect(btnHydroPlateSlopeShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("HydroPlate data slope")
	CKBShowSd["visible"] <- TRUE
	if (class(Data_hydroPlateSlope[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_hydroPlateSlope)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_hydroPlateSlope, DSd = Data_hydroPlateSlopeSd, T = Template, subnumber = "hydroPlateSlope")
		if (TEMPChecksums$Data_hydroPlateSlope[1] != TEMPChecksums$Data_hydroPlate[2] | TEMPChecksums$Data_hydroPlate[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: HydroPlate Average Miniatur clicked
################################################
gSignalConnect(btnHydroPlateAvShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Average HydroPlate data")
	if (SETAnalysisOpt$hydroPlate[2] == TRUE & SETAnalysisOpt$SD == TRUE) CKBShowSd["visible"] <- TRUE
	else {
		CKBShowSd["visible"] <- FALSE
		CKBShowSd$setActive(is.active = FALSE)
	}
	BXCurrentGraphIC50["visible"] <- FALSE
	if (class(Data_hydroPlateAv[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FTemplateMean()
		FCheckboxConstruct(Data_hydroPlateAv)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_hydroPlateAv, DSd = Data_hydroPlateSd, T = TemplateAverage, subnumber = "hydroPlateAv")
		if (TEMPChecksums$Data_hydroPlateAv[1] != TEMPChecksums$Data_hydroPlate[2] | TEMPChecksums$Data_hydroPlate[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Smoothed HydroPlate Average Miniatur clicked
#########################################################
gSignalConnect(btnHydroPlateAvSmShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Average HydroPlate data smoothed")
	CKBShowSd["visible"] <- FALSE
	CKBShowSd$setActive(is.active = FALSE)
	BXCurrentGraphIC50["visible"] <- FALSE
	if (class(Data_hydroPlateAvSm[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FTemplateMean()
		FCheckboxConstruct(Data_hydroPlateAvSm)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_hydroPlateAvSm, T = TemplateAverage, subnumber = "hydroPlateAvSm")
		if (TEMPChecksums$Data_hydroPlateAvSm[1] != TEMPChecksums$Data_hydroPlateAv[2] | TEMPChecksums$Data_hydroPlateAv[1] != TEMPChecksums$Data_hydroPlate[2] | TEMPChecksums$Data_hydroPlate[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

####
#### Signal: Slope of average HydroPlate Miniatur clicked
#########################################################
gSignalConnect(btnHydroPlateAvSlopeShow, "clicked", after = TRUE, quote({
	LBLCurrentGraphData$setLabel("Average HydroPlate data slope")
	CKBShowSd["visible"] <- TRUE
	if (class(Data_hydroPlateAvSlope[1,1]) == "NULL") {
		BXCurrentGraph$getChildren()[[1]]$destroy()
		LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
		BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
	} else {
		FCheckboxConstruct(Data_hydroPlateAvSlope)
		BXCurrentGraph$getChildren()[[1]]$destroy()
		FOpenCairo(LBLCurrentGraphData$getLabel())
		FPlotStandard(D = Data_hydroPlateAvSlope, DSd = Data_hydroPlateAvSlopeSd, T = TemplateAverage, subnumber = "hydroPlateAvSlope")
		if (TEMPChecksums$Data_hydroPlateAvSlope[1] != TEMPChecksums$Data_hydroPlateAv[2] | TEMPChecksums$Data_hydroPlateAv[1] != TEMPChecksums$Data_hydroPlate[2] | TEMPChecksums$Data_hydroPlate[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
	}
}))

#########################################################################################
#### Data output
#########################################################################################

#######################
#### Data output layout
#######################

####
#### Frame layout
#################

FROutOxoDish <- gtkFrame()
FROutOxoDishOrig <- gtkFrame()
FROutOxoDishSm <- gtkFrame()
FROutOxoDishSlope <- gtkFrame()
FROutOxoDishSlopeSd <- gtkFrame()
FROutOxoDishCons <- gtkFrame()
FROutOxoDishConsSd <- gtkFrame()
FROutOxoDishAv <- gtkFrame()
FROutOxoDishAvSm <- gtkFrame()
FROutOxoDishAvSlope <- gtkFrame()
FROutOxoDishAvSlopeSd <- gtkFrame()
FROutOxoDishAvCons <- gtkFrame()
FROutOxoDishAvConsSd <- gtkFrame()
FROutOxoDishSd <- gtkFrame()
FROutOxoPlate <- gtkFrame()
FROutOxoPlateOrig <- gtkFrame()
FROutOxoPlateSm <- gtkFrame()
FROutOxoPlateSlope <- gtkFrame()
FROutOxoPlateSlopeSd <- gtkFrame()
FROutOxoPlateCons <- gtkFrame()
FROutOxoPlateConsSd <- gtkFrame()
FROutOxoPlateAv <- gtkFrame()
FROutOxoPlateAvSm <- gtkFrame()
FROutOxoPlateAvSlope <- gtkFrame()
FROutOxoPlateAvSlopeSd <- gtkFrame()
FROutOxoPlateAvCons <- gtkFrame()
FROutOxoPlateAvConsSd <- gtkFrame()
FROutOxoPlateSd <- gtkFrame()
FROutHydroPlate <- gtkFrame()
FROutHydroPlateOrig <- gtkFrame()
FROutHydroPlateCal <- gtkFrame()
FROutHydroPlateSm <- gtkFrame()
FROutHydroPlateSlope <- gtkFrame()
FROutHydroPlateSlopeSd <- gtkFrame()
FROutHydroPlateAv <- gtkFrame()
FROutHydroPlateAvSm <- gtkFrame()
FROutHydroPlateAvSlope <- gtkFrame()
FROutHydroPlateAvSlopeSd <- gtkFrame()
FROutHydroPlateSd <- gtkFrame()

## delete entries according to version!
VectorOutputFramesObjects <- c(VectorOutputFramesObjects, "Data_oxoDish" = "FROutOxoDish", "Data_oxoDishOrig" = "FROutOxoDishOrig", "Data_oxoDishSm" = "FROutOxoDishSm", "Data_oxoDishSlope" = "FROutOxoDishSlope", "Data_oxoDishSlopeSd" = "FROutOxoDishSlopeSd", "Data_oxoDishCons" = "FROutOxoDishCons", "Data_oxoDishConsSd" = "FROutOxoDishConsSd",
								"Data_oxoDishAv" = "FROutOxoDishAv", "Data_oxoDishAvSm" = "FROutOxoDishAvSm", "Data_oxoDishAvSlope" = "FROutOxoDishAvSlope", "Data_oxoDishAvSlopeSd" = "FROutOxoDishAvSlopeSd", "Data_oxoDishAvCons" = "FROutOxoDishAvCons", "Data_oxoDishAvConsSd" = "FROutOxoDishAvConsSd", "Data_oxoDishSd" = "FROutOxoDishSd",
								"Data_oxoPlate" = "FROutOxoPlate", "Data_oxoPlateOrig" = "FROutOxoPlateOrig", "Data_oxoPlateSm" = "FROutOxoPlateSm", "Data_oxoPlateSlope" = "FROutOxoPlateSlope", "Data_oxoPlateSlopeSd" = "FROutOxoPlateSlopeSd", "Data_oxoPlateCons" = "FROutOxoPlateCons", "Data_oxoPlateConsSd" = "FROutOxoPlateConsSd",
								"Data_oxoPlateAv" = "FROutOxoPlateAv", "Data_oxoPlateAvSm" = "FROutOxoPlateAvSm", "Data_oxoPlateAvSlope" = "FROutOxoPlateAvSlope", "Data_oxoPlateAvSlopeSd" = "FROutOxoPlateAvSlopeSd", "Data_oxoPlateAvCons" = "FROutOxoPlateAvCons", "Data_oxoPlateAvConsSd" = "FROutOxoPlateAvConsSd", "Data_oxoPlateSd" = "FROutOxoPlateSd",
								"Data_hydroPlate" = "FROutHydroPlate", "Data_hydroPlateCal" = "FROutHydroPlateCal", "Data_hydroPlateSm" = "FROutHydroPlateSm", "Data_hydroPlateSlope" = "FROutHydroPlateSlope", "Data_hydroPlateSlopeSd" = "FROutHydroPlateSlopeSd",
								"Data_hydroPlateAv" = "FROutHydroPlateAv", "Data_hydroPlateOrig" = "FROutHydroPlateOrig", "Data_hydroPlateAvSm" = "FROutHydroPlateAvSm", "Data_hydroPlateAvSlope" = "FROutHydroPlateAvSlope", "Data_hydroPlateAvSlopeSd" = "FROutHydroPlateAvSlopeSd", "Data_hydroPlateSd" = "FROutHydroPlateSd")
VectorOutputFramesLabels <- c(VectorOutputFramesLabels, "Data_oxoDish" = "OxoDish data", "Data_oxoDishOrig" = "Unformatted OxoDish data", "Data_oxoDishSm" = "Smoothed OxoDish data", "Data_oxoDishSlope" = "Slope OxoDish data", "Data_oxoDishSlopeSd" = "Deviation slope OxoDish data", "Data_oxoDishCons" = "Consumption from OxoDish data", "Data_oxoDishConsSd" = "Deviation consumption from OxoDish data",
								"Data_oxoDishAv" = "Average OxoDish data", "Data_oxoDishAvSm" = "Smoothed average OxoDish data", "Data_oxoDishAvSlope" = "Slope average OxoDish data", "Data_oxoDishAvSlopeSd" = "Deviation slope average OxoDish data", "Data_oxoDishAvCons" = "Consumption from average OxoDish data", "Data_oxoDishAvConsSd" = "Deviation consumption from average OxoDish data", "Data_oxoDishSd" = "OxoDish data standard deviation",
								"Data_oxoPlate" = "OxoPlate data", "Data_oxoPlateOrig" = "Unformatted OxoPlate data", "Data_oxoPlateSm" = "Smoothed OxoPlate data", "Data_oxoPlateSlope" = "Slope OxoPlate data", "Data_oxoPlateSlopeSd" = "Deviation slope OxoPlate data", "Data_oxoPlateCons" = "Consumption from OxoPlate data", "Data_oxoPlateConsSd" = "Deviation consumption from OxoPlate data",
								"Data_oxoPlateAv" = "Average OxoPlate data", "Data_oxoPlateAvSm" = "Smoothed average OxoPlate data", "Data_oxoPlateAvSlope" = "Slope average OxoPlate data", "Data_oxoPlateAvSlopeSd" = "Deviation slope average OxoPlate data", "Data_oxoPlateAvCons" = "Consumption from average OxoPlate data", "Data_oxoPlateAvConsSd" = "Deviation consumption from average OxoPlate data", "Data_oxoPlateSd" = "OxoPlate data standard deviation",
								"Data_hydroPlate" = "HydroPlate data", "Data_hydroPlateOrig" = "Unformatted HydroPlate data", "Data_hydroPlateCal" = "Calibration values for HydroPlate data", "Data_hydroPlateSm" = "Smoothed HydroPlate data", "Data_hydroPlateSlope" = "Slope HydroPlate data", "Data_hydroPlateSlopeSd" = "Deviation slope HydroPlate data",
								"Data_hydroPlateAv" = "Average HydroPlate data", "Data_hydroPlateAvSm" = "Smoothed average HydroPlate data", "Data_hydroPlateAvSlope" = "Slope average HydroPlate data", "Data_hydroPlateAvSlopeSd" = "Deviation slope average HydroPlate data", "Data_hydroPlateSd" = "HydroPlate data standard deviation")

for (i in 1:length(VectorOutputFramesObjects)) gtkContainerSetBorderWidth(get(VectorOutputFramesObjects[i]), 2)

	layoutDataOutput$packStart(LBLDataOutputFrame, expand = FALSE, fill = FALSE)
	layoutDataOutput$packStart(BXOutputSeparators, expand = FALSE, fill = FALSE)
	for (i in 1:length(VectorOutputFramesObjects)) layoutDataOutput$packStart(get(VectorOutputFramesObjects[i]), expand = FALSE, fill = FALSE)
	layoutDataOutput$packStart(BXOutputExecute, expand = FALSE, fill = FALSE)

####
#### Output Layouts
###################

ListOutputLayouts <- list()
#1 is HBox, 2 is LBL, 3 is CKB, 4 is ENT

for (i in 1:length(VectorOutputFramesObjects)) {
	output <- names(VectorOutputFramesObjects[i])
	ListOutputLayouts[[output]] <- list()
	ListOutputLayouts[[output]]$box <- gtkHBox(FALSE, 5)
	gtkContainerAdd(get(VectorOutputFramesObjects[i]), ListOutputLayouts[[output]][["box"]])
	ListOutputLayouts[[output]]$label <- gtkLabel(VectorOutputFramesLabels[output])
	ListOutputLayouts[[output]][["label"]]$setSizeRequest(320, -1)
	ListOutputLayouts[[output]]$ckb <- gtkCheckButton("export to file")
	ListOutputLayouts[[output]]$entry <- gtkEntry()
	ListOutputLayouts[[output]][["entry"]]$setSizeRequest(-1, 20)
	ListOutputLayouts[[output]][["box"]]$packStart(ListOutputLayouts[[output]][["label"]], expand = FALSE, fill = FALSE)
	ListOutputLayouts[[output]][["box"]]$packStart(ListOutputLayouts[[output]][["ckb"]], expand = FALSE, fill = FALSE)
	ListOutputLayouts[[output]][["box"]]$packStart(ListOutputLayouts[[output]][["entry"]], expand = TRUE, fill = TRUE)
}

############################
#### Data output interactive
############################

####
#### Signal: Export or not
##########################
####
#### Function: Setting and hide according to tick
#################################################
FOutputSelection <- function(Data) {
	value <- ListOutputLayouts[[Data]][["ckb"]]$getActive()
	SETDataOutput$export[Data] <<- value
	ListOutputLayouts[[Data]][["entry"]]["visible"] <- value
	#print(SETDataOutput$export)
}

#### Raw data sets
gSignalConnect(ListOutputLayouts[["Data_raw"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_raw")))
gSignalConnect(ListOutputLayouts[["Data_rawOrig"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_rawOrig")))
gSignalConnect(ListOutputLayouts[["Data_rawSm"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_rawSm")))
gSignalConnect(ListOutputLayouts[["Data_rawSlope"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_rawSlope")))
gSignalConnect(ListOutputLayouts[["Data_rawSlopeSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_rawSlopeSd")))
gSignalConnect(ListOutputLayouts[["Data_rawCons"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_rawCons")))
gSignalConnect(ListOutputLayouts[["Data_rawConsSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_rawConsSd")))
gSignalConnect(ListOutputLayouts[["Data_rawAv"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_rawAv")))
gSignalConnect(ListOutputLayouts[["Data_rawAvSm"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_rawAvSm")))
gSignalConnect(ListOutputLayouts[["Data_rawAvSlope"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_rawAvSlope")))
gSignalConnect(ListOutputLayouts[["Data_rawAvSlopeSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_rawAvSlopeSd")))
gSignalConnect(ListOutputLayouts[["Data_rawAvCons"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_rawAvCons")))
gSignalConnect(ListOutputLayouts[["Data_rawAvConsSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_rawAvConsSd")))
gSignalConnect(ListOutputLayouts[["Data_rawSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_rawSd")))

#### Medium data sets
gSignalConnect(ListOutputLayouts[["Data_medium"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_medium")))
gSignalConnect(ListOutputLayouts[["Data_mediumOrig"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_mediumOrig")))
gSignalConnect(ListOutputLayouts[["Data_mediumSm"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_mediumSm")))
gSignalConnect(ListOutputLayouts[["Data_mediumSlope"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_mediumSlope")))
gSignalConnect(ListOutputLayouts[["Data_mediumSlopeSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_mediumSlopeSd")))
gSignalConnect(ListOutputLayouts[["Data_mediumCons"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_mediumCons")))
gSignalConnect(ListOutputLayouts[["Data_mediumConsSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_mediumConsSd")))
gSignalConnect(ListOutputLayouts[["Data_mediumAv"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_mediumAv")))
gSignalConnect(ListOutputLayouts[["Data_mediumAvSm"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_mediumAvSm")))
gSignalConnect(ListOutputLayouts[["Data_mediumAvSlope"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_mediumAvSlope")))
gSignalConnect(ListOutputLayouts[["Data_mediumAvSlopeSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_mediumAvSlopeSd")))
gSignalConnect(ListOutputLayouts[["Data_mediumAvCons"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_mediumAvCons")))
gSignalConnect(ListOutputLayouts[["Data_mediumAvConsSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_mediumAvConsSd")))
gSignalConnect(ListOutputLayouts[["Data_mediumSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_mediumSd")))

#### IC50 data set
gSignalConnect(ListOutputLayouts[["Data_IC50"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_IC50")))

#### OxoDish data sets
gSignalConnect(ListOutputLayouts[["Data_oxoDish"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoDish")))
gSignalConnect(ListOutputLayouts[["Data_oxoDishOrig"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoDishOrig")))
gSignalConnect(ListOutputLayouts[["Data_oxoDishSm"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoDishSm")))
gSignalConnect(ListOutputLayouts[["Data_oxoDishSlope"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoDishSlope")))
gSignalConnect(ListOutputLayouts[["Data_oxoDishSlopeSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoDishSlopeSd")))
gSignalConnect(ListOutputLayouts[["Data_oxoDishCons"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoDishCons")))
gSignalConnect(ListOutputLayouts[["Data_oxoDishConsSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoDishConsSd")))
gSignalConnect(ListOutputLayouts[["Data_oxoDishAv"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoDishAv")))
gSignalConnect(ListOutputLayouts[["Data_oxoDishAvSm"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoDishAvSm")))
gSignalConnect(ListOutputLayouts[["Data_oxoDishAvSlope"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoDishAvSlope")))
gSignalConnect(ListOutputLayouts[["Data_oxoDishAvSlopeSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoDishAvSlopeSd")))
gSignalConnect(ListOutputLayouts[["Data_oxoDishAvCons"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoDishAvCons")))
gSignalConnect(ListOutputLayouts[["Data_oxoDishAvConsSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoDishAvConsSd")))
gSignalConnect(ListOutputLayouts[["Data_oxoDishSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoDishSd")))

#### OxoPlate data sets
gSignalConnect(ListOutputLayouts[["Data_oxoPlate"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoPlate")))
gSignalConnect(ListOutputLayouts[["Data_oxoPlateOrig"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoPlateOrig")))
gSignalConnect(ListOutputLayouts[["Data_oxoPlateSm"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoPlateSm")))
gSignalConnect(ListOutputLayouts[["Data_oxoPlateSlope"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoPlateSlope")))
gSignalConnect(ListOutputLayouts[["Data_oxoPlateSlopeSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoPlateSlopeSd")))
gSignalConnect(ListOutputLayouts[["Data_oxoPlateCons"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoPlateCons")))
gSignalConnect(ListOutputLayouts[["Data_oxoPlateConsSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoPlateConsSd")))
gSignalConnect(ListOutputLayouts[["Data_oxoPlateAv"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoPlateAv")))
gSignalConnect(ListOutputLayouts[["Data_oxoPlateAvSm"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoPlateAvSm")))
gSignalConnect(ListOutputLayouts[["Data_oxoPlateAvSlope"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoPlateAvSlope")))
gSignalConnect(ListOutputLayouts[["Data_oxoPlateAvSlopeSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoPlateAvSlopeSd")))
gSignalConnect(ListOutputLayouts[["Data_oxoPlateAvCons"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoPlateAvCons")))
gSignalConnect(ListOutputLayouts[["Data_oxoPlateAvConsSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoPlateAvConsSd")))
gSignalConnect(ListOutputLayouts[["Data_oxoPlateSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_oxoPlateSd")))

#### HydroPlate data sets
gSignalConnect(ListOutputLayouts[["Data_hydroPlate"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_hydroPlate")))
gSignalConnect(ListOutputLayouts[["Data_hydroPlateOrig"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_hydroPlateOrig")))
gSignalConnect(ListOutputLayouts[["Data_hydroPlateCal"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_hydroPlateCal")))
gSignalConnect(ListOutputLayouts[["Data_hydroPlateSm"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_hydroPlateSm")))
gSignalConnect(ListOutputLayouts[["Data_hydroPlateSlope"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_hydroPlateSlope")))
gSignalConnect(ListOutputLayouts[["Data_hydroPlateSlopeSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_hydroPlateSlopeSd")))
gSignalConnect(ListOutputLayouts[["Data_hydroPlateAv"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_hydroPlateAv")))
gSignalConnect(ListOutputLayouts[["Data_hydroPlateAvSm"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_hydroPlateAvSm")))
gSignalConnect(ListOutputLayouts[["Data_hydroPlateAvSlope"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_hydroPlateAvSlope")))
gSignalConnect(ListOutputLayouts[["Data_hydroPlateAvSlopeSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_hydroPlateAvSlopeSd")))
gSignalConnect(ListOutputLayouts[["Data_hydroPlateSd"]][[3]], "toggled", quote(FOutputSelection(Data = "Data_hydroPlateSd")))

########################
#### Data Output Execute
########################

####
#### Function: Activate all input for Data Output:
##################################################
FCheckDataOutput <- function(Input) {
	for (i in 1:length(Input)) {
		if (class(Input[[i]])[1] == "GtkEntry") {
			gSignalEmit(Input[[i]], "activate")
		} else if (class(Input[[i]])[1] == "GtkCheckButton") {
			gSignalEmit(Input[[i]], "toggled")
		}
	}
	for(i in 1:length(VectorOutputFramesLabels)) {
		gSignalEmit(ListOutputLayouts[[names(VectorOutputFramesLabels[i])]][[3]], "toggled")
	}
	
	#### Check on required filenames
	for (i in 1:length(SETDataOutput$export)) {
		SETDataOutput$filenames[names(SETDataOutput$export[i])] <<- ListOutputLayouts[[names(SETDataOutput$export[i])]][["entry"]]$getText()
		if (SETDataOutput$export[i] == TRUE & SETDataOutput$filenames[names(SETDataOutput$export[i])] == "") {
			ERROutFilename["visible"] <- TRUE
			break
		} else {
			ERROutFilename["visible"] <- FALSE
		}
	}
}

#### Elements for Formatting selection update
FormattingResultsInterfaces <- c(BXPlotGeneralSubRawOrig, FROutRawOrig, btnRawOrigShow, BXPlotGeneralSubOxoDishOrig, BXPlotGeneralSubMediumOrig, FROutMediumOrig, btnMediumOrigShow, FROutOxoDishOrig, btnOxoDishOrigShow, BXPlotGeneralSubOxoPlateOrig, FROutOxoPlateOrig, btnOxoPlateOrigShow, BXPlotGeneralSubHydroPlateOrig, FROutHydroPlateOrig, btnHydroPlateOrigShow)

#########################################################################################
#### Run Analysis
#########################################################################################

#############################
#### Run Analysis interactive
#############################

####
#### Signal: Rerun OxoDish
##########################
gSignalConnect(btnOxoDishCalRerun, "clicked", quote({
	POPUpdateAnalysis <- gtkMessageDialog(mainApplication, "destroy-with-parent", "question", "yes-no", "Do you also want to update the analyses based on the sensor correction?")
	response <- POPUpdateAnalysis$run()
	if (response == GtkResponseType["yes"] | response == GtkResponseType["no"]) {
		if (FCheckBeforeAnalysis() == TRUE) {
			POPUpdateAnalysis$destroy()
			FStartAnalysis(rerun = TRUE)
			FCalculationOxoDish(Data_raw)
			TEMPChecksums$Data_oxoDish[1] <- sum(colSums(Data_raw))	
			TEMPChecksums$Data_oxoDish[2] <- sum(colSums(Data_oxoDish))
			print("Data oxoDish")
			print(Data_oxoDish[1:10,])
			if (response == GtkResponseType["yes"]) {
				FRunAnalysis(rerun = TRUE)
			}
			FEndAnalysis()
		}
	} else {
		POPUpdateAnalysis$destroy()
	}
}))

####
#### Signal: Rerun OxoPlate
###########################
gSignalConnect(btnOxoPlateCalRerun, "clicked", quote({
	POPUpdateAnalysis <- gtkMessageDialog(mainApplication, "destroy-with-parent", "question", "yes-no", "Do you also want to update the analyses based on the OxoPlate conversion?")
	response <- POPUpdateAnalysis$run()
	if (response == GtkResponseType["yes"] | response == GtkResponseType["no"]) {
		if (FCheckBeforeAnalysis() == TRUE) {
			POPUpdateAnalysis$destroy()
			FStartAnalysis(rerun = TRUE)
			FCalculationOxoPlate(Data_raw)
			TEMPChecksums$Data_oxoPlate[1] <- sum(colSums(Data_raw))
			TEMPChecksums$Data_oxoPlate[2] <- sum(colSums(Data_oxoPlate))
			print("Data oxoPlate")
			print(Data_oxoPlate[1:10,])
			if (response == GtkResponseType["yes"]) {
				FRunAnalysis(rerun = TRUE)
			}
			FEndAnalysis()
		}
	} else {
		POPUpdateAnalysis$destroy()
	}
}))

####
#### Signal: Rerun HydroPlate
###########################
gSignalConnect(btnHydroPlateCalRerun, "clicked", quote({
	POPUpdateAnalysis <- gtkMessageDialog(mainApplication, "destroy-with-parent", "question", "yes-no", "Do you also want to update the analyses based on the HydroPlate conversion?")
	response <- POPUpdateAnalysis$run()
	if (response == GtkResponseType["yes"] | response == GtkResponseType["no"]) {
		if (FCheckBeforeAnalysis() == TRUE) {
			POPUpdateAnalysis$destroy()
			FStartAnalysis(rerun = TRUE)
			FCalculationHydroPlate()
			TEMPChecksums$Data_hydroPlate[1] <<- sum(colSums(Data_raw))
			TEMPChecksums$Data_hydroPlate[2] <<- sum(colSums(Data_hydroPlate))
			TEMPChecksums$Data_hydroPlateCal[1] <<- sum(colSums(Data_raw))
			TEMPChecksums$Data_hydroPlateCal[2] <<- sum(colSums(Data_hydroPlateCal))
			print("Data hydroPlate")
			print(Data_hydroPlate[1:10,])
			print("Data hydroPlate calibration values")
			print(Data_hydroPlateCal[1:10,])
			if (response == GtkResponseType["yes"]) {
				FRunAnalysis(rerun = TRUE)
			}
			FEndAnalysis()
		}
	} else {
		POPUpdateAnalysis$destroy()
	}
}))

FShowRerunButtons <- function() {
	
	if (firstAnalysis == TRUE) {
		btnFormattingRerun["visible"] <- TRUE
		btnOxoDishCalRerun["visible"] <- TRUE
		btnOxoPlateCalRerun["visible"] <- TRUE
		btnHydroPlateCalRerun["visible"] <- TRUE
		btnAverageRerun["visible"] <- TRUE
		btnMediumCalRerun["visible"] <- TRUE
		btnSmoothRerun["visible"] <- TRUE
		btnSlopeRerun["visible"] <- TRUE
		btnConsRerun["visible"] <- TRUE
		btnIC50Rerun["visible"] <- TRUE
		firstAnalysis <<- FALSE
	}
}